/*
 * Licensed under the terms of the GNU GENERAL PUBLIC LICENSE version 2.
 * See file COPYING for details.
 */

#ifndef fam11h_h
#define fam11h_h

#include "../msr.h"

_RANGE(fam11h_LSMCAaddr,48,16,0);
_NAMES(fam11h_LSMCAaddr,"ADDR",0);
_RANGE(fam11h_LSMCAstatus,16,29,1,1,10,1,1,1,1,1,1,1,0);
_NAMES(fam11h_LSMCAstatus,"ErrorCode",0,"UECC","CECC",0,"PCC","ADDRV","MISCV","EN","UC","OVER","VAL");
_RANGE(fam11h_TSC,64,0);
_NAMES(fam11h_TSC,"TSC");
_RANGE(fam11h_APIC_BASE,8,1,2,1,36,16,0);
_NAMES(fam11h_APIC_BASE,0,"BSC",0,"ApicEn","ApicBar",0);
_RANGE(fam11h_EBL_CR_POWERON,16,2,46,0);
_NAMES(fam11h_EBL_CR_POWERON,0,"ClusterID",0);
_RANGE(fam11h_PATCH_LEVEL,32,32,0);
_NAMES(fam11h_PATCH_LEVEL,"PATCH_LEVEL",0);
_RANGE(fam11h_MTRRcap,8,1,1,1,53,0);
_NAMES(fam11h_MTRRcap,"MtrrCapVCnt","MtrrCapFix",0,"MtrrCapWc",0);
_RANGE(fam11h_SYSENTER_CS,16,48,0);
_NAMES(fam11h_SYSENTER_CS,"SYSENTER_CS",0);
_RANGE(fam11h_SYSENTER_ESP,32,32,0);
_NAMES(fam11h_SYSENTER_ESP,"SYSENTER_ESP",0);
_RANGE(fam11h_SYSENTER_EIP,32,32,0);
_NAMES(fam11h_SYSENTER_EIP,"SYSENTER_EIP",0);
_RANGE(fam11h_MCG_CAP,8,1,55,0);
_NAMES(fam11h_MCG_CAP,"Count","MCG_CTL_P",0);
_RANGE(fam11h_MCG_STAT,1,1,1,61,0);
_NAMES(fam11h_MCG_STAT,"RIPV","EIPV","MCIP",0);
_RANGE(fam11h_MCG_CTL,1,1,1,1,1,1,58,0);
_NAMES(fam11h_MCG_CTL,"DCE","ICE","BUE","LSE","NBE","FRE",0);
_RANGE(fam11h_DBG_CTL_MSR,1,1,1,1,1,1,58,0);
_NAMES(fam11h_DBG_CTL_MSR,"LBR","BTF","PB0","PB1","PB2","PB3",0);
_RANGE(fam11h_BR_FROM,64,0);
_NAMES(fam11h_BR_FROM,"LastBranchFromIP");
_RANGE(fam11h_BR_TO,64,0);
_NAMES(fam11h_BR_TO,"LastBranchToIP");
_RANGE(fam11h_LastExceptionFromIP,64,0);
_NAMES(fam11h_LastExceptionFromIP,"LastIntFromIP");
_RANGE(fam11h_LastExceptionToIP,64,0);
_NAMES(fam11h_LastExceptionToIP,"LastIntToIP");
_RANGE(fam11h_MTRRphysBase0,8,4,36,16,0);
_NAMES(fam11h_MTRRphysBase0,"MemType",0,"PhyBase",0);
_RANGE(fam11h_MTRRphysMask0,11,1,36,16,0);
_NAMES(fam11h_MTRRphysMask0,0,"Valid","PhysMask",0);
_RANGE(fam11h_MTRRphysBase1,8,4,36,16,0);
_NAMES(fam11h_MTRRphysBase1,"MemType",0,"PhyBase",0);
_RANGE(fam11h_MTRRphysMask1,11,1,36,16,0);
_NAMES(fam11h_MTRRphysMask1,0,"Valid","PhysMask",0);
_RANGE(fam11h_MTRRphysBase2,8,4,36,16,0);
_NAMES(fam11h_MTRRphysBase2,"MemType",0,"PhyBase",0);
_RANGE(fam11h_MTRRphysMask2,11,1,36,16,0);
_NAMES(fam11h_MTRRphysMask2,0,"Valid","PhysMask",0);
_RANGE(fam11h_MTRRphysBase3,8,4,36,16,0);
_NAMES(fam11h_MTRRphysBase3,"MemType",0,"PhyBase",0);
_RANGE(fam11h_MTRRphysMask3,11,1,36,16,0);
_NAMES(fam11h_MTRRphysMask3,0,"Valid","PhysMask",0);
_RANGE(fam11h_MTRRphysBase4,8,4,36,16,0);
_NAMES(fam11h_MTRRphysBase4,"MemType",0,"PhyBase",0);
_RANGE(fam11h_MTRRphysMask4,11,1,36,16,0);
_NAMES(fam11h_MTRRphysMask4,0,"Valid","PhysMask",0);
_RANGE(fam11h_MTRRphysBase5,8,4,36,16,0);
_NAMES(fam11h_MTRRphysBase5,"MemType",0,"PhyBase",0);
_RANGE(fam11h_MTRRphysMask5,11,1,36,16,0);
_NAMES(fam11h_MTRRphysMask5,0,"Valid","PhysMask",0);
_RANGE(fam11h_MTRRphysBase6,8,4,36,16,0);
_NAMES(fam11h_MTRRphysBase6,"MemType",0,"PhyBase",0);
_RANGE(fam11h_MTRRphysMask6,11,1,36,16,0);
_NAMES(fam11h_MTRRphysMask6,0,"Valid","PhysMask",0);
_RANGE(fam11h_MTRRphysBase7,8,4,36,16,0);
_NAMES(fam11h_MTRRphysBase7,"MemType",0,"PhyBase",0);
_RANGE(fam11h_MTRRphysMask7,11,1,36,16,0);
_NAMES(fam11h_MTRRphysMask7,0,"Valid","PhysMask",0);
_RANGE(fam11h_MTRRfix64K_00000,8,8,8,8,8,8,8,8,0);
_NAMES(fam11h_MTRRfix64K_00000,"0xxxxType","1xxxxType","2xxxxType","3xxxxType","4xxxxType","5xxxxType","6xxxxType","7xxxxType");
_RANGE(fam11h_MTRRfix16K_80000,8,8,8,8,8,8,8,8,0);
_NAMES(fam11h_MTRRfix16K_80000,"80xxxType","84xxxType","88xxxType","8CxxxType","90xxxType","94xxxType","98xxxType","9CxxxType");
_RANGE(fam11h_MTRRfix16K_A0000,8,8,8,8,8,8,8,8,0);
_NAMES(fam11h_MTRRfix16K_A0000,"A0xxxType","A4xxxType","A8xxxType","ACxxxType","B0xxxType","B4xxxType","B8xxxType","BCxxxType");
_RANGE(fam11h_MTRRfix4K_C0000,8,8,8,8,8,8,8,8,0);
_NAMES(fam11h_MTRRfix4K_C0000,"C0xxxType","C1xxxType","C2xxxType","C3xxxType","C4xxxType","C5xxxType","C6xxxType","C7xxxType");
_RANGE(fam11h_MTRRfix4K_C8000,8,8,8,8,8,8,8,8,0);
_NAMES(fam11h_MTRRfix4K_C8000,"C8xxxType","C9xxxType","CAxxxType","CBxxxType","CCxxxType","CDxxxType","CExxxType","CFxxxType");
_RANGE(fam11h_MTRRfix4K_D0000,8,8,8,8,8,8,8,8,0);
_NAMES(fam11h_MTRRfix4K_D0000,"D0xxxType","D1xxxType","D2xxxType","D3xxxType","D4xxxType","D5xxxType","D6xxxType","D7xxxType");
_RANGE(fam11h_MTRRfix4K_D8000,8,8,8,8,8,8,8,8,0);
_NAMES(fam11h_MTRRfix4K_D8000,"D8xxxType","D9xxxType","DAxxxType","DBxxxType","DCxxxType","DDxxxType","DExxxType","DFxxxType");
_RANGE(fam11h_MTRRfix4K_E0000,8,8,8,8,8,8,8,8,0);
_NAMES(fam11h_MTRRfix4K_E0000,"E0xxxType","E1xxxType","E2xxxType","E3xxxType","E4xxxType","E5xxxType","E6xxxType","E7xxxType");
_RANGE(fam11h_MTRRfix4K_E8000,8,8,8,8,8,8,8,8,0);
_NAMES(fam11h_MTRRfix4K_E8000,"E8xxxType","E9xxxType","EAxxxType","EBxxxType","ECxxxType","EDxxxType","EExxxType","EFxxxType");
_RANGE(fam11h_MTRRfix4K_F0000,8,8,8,8,8,8,8,8,0);
_NAMES(fam11h_MTRRfix4K_F0000,"F0xxxType","F1xxxType","F2xxxType","F3xxxType","F4xxxType","F5xxxType","F6xxxType","F7xxxType");
_RANGE(fam11h_MTRRfix4K_F8000,8,8,8,8,8,8,8,8,0);
_NAMES(fam11h_MTRRfix4K_F8000,"F8xxxType","F9xxxType","FAxxxType","FBxxxType","FCxxxType","FDxxxType","FExxxType","FFxxxType");
_RANGE(fam11h_PAT,3,5,3,5,3,5,3,5,3,5,3,5,3,5,3,5,0);
_NAMES(fam11h_PAT,"PA0MemType",0,"PA1MemType",0,"PA2MemType",0,"PA3MemType",0,"PA4MemType",0,"PA5MemType",0,"PA6MemType",0,"PA7MemType",0);
_RANGE(fam11h_MTRRdefType,8,2,1,1,52,0);
_NAMES(fam11h_MTRRdefType,"MemType",0,"MtrrDefTypeFixEn","MtrrDefTypeEn",0);
_RANGE(fam11h_MC0_CTL,1,1,1,1,1,1,1,57,0);
_NAMES(fam11h_MC0_CTL,"ECCI","ECCM","DECC","DMTP","DSTP","L1TP","L2TP",0);
_RANGE(fam11h_MC0_STATUS,16,4,20,1,4,1,1,8,2,1,1,1,1,1,1,1,0);
_NAMES(fam11h_MC0_STATUS,"ErrorCode","ErrorCodeExt",0,"Scrub",0,"UECC","CECC","Syndrome",0,"PCC","AddrV","MiscV","En","UC","OVER","VAL");
_RANGE(fam11h_MC0_ADDR,48,16,0);
_NAMES(fam11h_MC0_ADDR,"ADDR",0);
_RANGE(fam11h_MC0_MISC,64,0);
_NAMES(fam11h_MC0_MISC,0);
_RANGE(fam11h_MC1_CTL,1,1,1,1,1,1,1,2,1,54,0);
_NAMES(fam11h_MC1_CTL,"ECCI","ECCM","IDP","IMTP","ISTP","L1TP","L2TP",0,"RDDE",0);
_RANGE(fam11h_MC1_STATUS,16,4,25,1,1,10,1,1,1,1,1,1,1,0);
_NAMES(fam11h_MC1_STATUS,"ErrorCode","ErrorCodeExt",0,"UECC","CECC",0,"PCC","AddrV","MiscV","En","UC","OVER","VAL");
_RANGE(fam11h_MC1_ADDR,48,16,0);
_NAMES(fam11h_MC1_ADDR,"ADDR",0);
_RANGE(fam11h_MC1_MISC,64,0);
_NAMES(fam11h_MC1_MISC,0);
_RANGE(fam11h_MC2_CTL,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,44,0);
_NAMES(fam11h_MC2_CTL,"S_RDE_HP","S_RDE_TLB","S_RDE_ALL","S_ECC1_TLB","S_ECC1_HP","S_ECCM_TLB","S_ECCM_HP","L2T_PAR_ICDC","L2T_PAR_TLB","L2_PAR_SNP","L2_PAR_CPB","L2_PAR_SCR","L2D_ECC1_TLB","L2D_ECC1_SNP","L2D_ECC1_CPB","L2D_ECCM_TLB","L2D_ECCM_SNP","L2D_ECCM_CPB","L2T_ECC1_SCR","L2T_ECCM_SCR",0);
_RANGE(fam11h_MC2_STATUS,16,4,25,1,1,10,1,1,1,1,1,1,1,0);
_NAMES(fam11h_MC2_STATUS,"ErrorCode","ErrorCodeExt",0,"UECC","CECC",0,"PCC","AddrV","MiscV","En","UC","OVER","VAL");
_RANGE(fam11h_MC2_ADDR,48,16,0);
_NAMES(fam11h_MC2_ADDR,"ADDR",0);
_RANGE(fam11h_MC2_MISC,64,0);
_NAMES(fam11h_MC2_MISC,0);
_RANGE(fam11h_MC3_CTL,1,1,62,0);
_NAMES(fam11h_MC3_CTL,"S_RDE_L","S_RDE_S",0);
_RANGE(fam11h_MC3_STATUS,16,29,1,1,10,1,1,1,1,1,1,1,0);
_NAMES(fam11h_MC3_STATUS,"ErrorCode",0,"UECC","CECC",0,"PCC","ADDRV","MISCV","EN","UC","OVER","VAL");
_RANGE(fam11h_MC3_ADDR,48,16,0);
_NAMES(fam11h_MC3_ADDR,"ADDR",0);
_RANGE(fam11h_MC3_MISC,64,0);
_NAMES(fam11h_MC3_MISC,0);
_RANGE(fam11h_MC4_CTL,2,1,2,1,2,1,1,1,1,1,1,2,1,1,1,1,5,1,1,1,36,0);
_NAMES(fam11h_MC4_CTL,0,"CrcErr0En",0,"SyncPkt0En",0,"MstrAbrtEn","TgtAbrtEn",0,"AtomicRMWEn","WDTRptEn","DevErrEn",0,"HtProtEn","HtDataEn",0,"RtryHt0En",0,"McaUsPwDatErrEn",0,"TblWlkDatErrEn",0);
_RANGE(fam11h_MC4_STATUS,16,5,11,1,1,2,1,4,1,15,1,1,1,1,1,1,1,0);
_NAMES(fam11h_MC4_STATUS,"ErrorCode","ErrorCodeExt",0,"ErrCpu0","ErrCpu1",0,"LDTLink",0,"SubLink",0,"PCC","AddrV",0,"En","UC","Over","Val");
_RANGE(fam11h_MC4_ADDR,64,0);
_NAMES(fam11h_MC4_ADDR,"NBaddr");
_RANGE(fam11h_EFER,1,7,1,1,1,1,1,1,1,49,0);
_NAMES(fam11h_EFER,"SYSCALL",0,"LME",0,"LMA","NXE","SVME","LMSLE","FFXSE",0);
_RANGE(fam11h_STAR,32,16,16,0);
_NAMES(fam11h_STAR,"Target","SysCallSel","SysRetSel");
_RANGE(fam11h_STAR64,64,0);
_NAMES(fam11h_STAR64,"LSTAR");
_RANGE(fam11h_STARCOMPAT,64,0);
_NAMES(fam11h_STARCOMPAT,"CSTAR");
_RANGE(fam11h_SYSCALL_FLAG_MASK,32,32,0);
_NAMES(fam11h_SYSCALL_FLAG_MASK,"MASK",0);
_RANGE(fam11h_FS_BASE,64,0);
_NAMES(fam11h_FS_BASE,"FS_BASE");
_RANGE(fam11h_GS_BASE,64,0);
_NAMES(fam11h_GS_BASE,"GS_BASE");
_RANGE(fam11h_KernelGSbase,64,0);
_NAMES(fam11h_KernelGSbase,"KernelGSBase");
_RANGE(fam11h_TSC_AUX,32,32,0);
_NAMES(fam11h_TSC_AUX,"TscAux",0);
_RANGE(fam11h_PERF_CTL0,8,8,1,1,1,1,1,1,1,1,8,4,28,0);
_NAMES(fam11h_PERF_CTL0,"EventSelect","UnitMask","User","OS","Edge","PC","Int",0,"En","Inv","CntMask","EventSelect",0);
_RANGE(fam11h_PERF_CTL1,8,8,1,1,1,1,1,1,1,1,8,4,28,0);
_NAMES(fam11h_PERF_CTL1,"EventSelect","UnitMask","User","OS","Edge","PC","Int",0,"En","Inv","CntMask","EventSelect",0);
_RANGE(fam11h_PERF_CTL2,8,8,1,1,1,1,1,1,1,1,8,4,28,0);
_NAMES(fam11h_PERF_CTL2,"EventSelect","UnitMask","User","OS","Edge","PC","Int",0,"En","Inv","CntMask","EventSelect",0);
_RANGE(fam11h_PERF_CTL3,8,8,1,1,1,1,1,1,1,1,8,4,28,0);
_NAMES(fam11h_PERF_CTL3,"EventSelect","UnitMask","User","OS","Edge",0,"Int",0,"En","Inv","CntMask","EventSelect",0);
_RANGE(fam11h_PERF_CTR0,48,16,0);
_NAMES(fam11h_PERF_CTR0,"CTR",0);
_RANGE(fam11h_PERF_CTR1,48,16,0);
_NAMES(fam11h_PERF_CTR1,"CTR",0);
_RANGE(fam11h_PERF_CTR2,48,16,0);
_NAMES(fam11h_PERF_CTR2,"CTR",0);
_RANGE(fam11h_PERF_CTR3,48,16,0);
_NAMES(fam11h_PERF_CTR3,"CTR",0);
_RANGE(fam11h_SYS_CFG,5,3,1,1,1,5,1,1,1,1,1,1,1,41,0);
_NAMES(fam11h_SYS_CFG,"SysAckLimit","SysVicLimit",0,"SetDirtyEnS","SetDirtyEnO",0,"ChxToDirtyDis","SysUcLockEn","MtrrFixDramEn","MtrrFixDramModeEn","MtrrVarDramEn","MtrrTom2En","Tom2ForceMemTypeWB",0);
_RANGE(fam11h_HWCR,1,1,1,1,1,1,1,1,1,4,1,1,1,1,1,1,1,1,2,1,1,39,0);
_NAMES(fam11h_HWCR,"SmmLock","SlowFence",0,"TlbCacheDis","INVD_WBINVD",0,"FFDIS","DisLock","IgnneEm",0,"SmiSpCycDis","RsmSpCycDis","SseDis",0,"Wrap32Dis","McStatusWrEn",0,"IoCfgGpFault",0,"ForceUsRdWrSzPrb","TscFreqSel",0);
_RANGE(fam11h_IORR_BASE0,3,1,1,7,36,16,0);
_NAMES(fam11h_IORR_BASE0,0,"WrMem","RdMem",0,"PhyBase",0);
_RANGE(fam11h_IORR_MASK0,11,1,36,16,0);
_NAMES(fam11h_IORR_MASK0,0,"Valid","PhyMask",0);
_RANGE(fam11h_IORR_BASE1,3,1,1,7,36,16,0);
_NAMES(fam11h_IORR_BASE1,0,"WrMem","RdMem",0,"PhyBase",0);
_RANGE(fam11h_IORR_MASK1,11,1,36,16,0);
_NAMES(fam11h_IORR_MASK1,0,"Valid","PhyMask",0);
_RANGE(fam11h_TOP_MEM,23,17,24,0);
_NAMES(fam11h_TOP_MEM,0,"TOM",0);
_RANGE(fam11h_TOM2,23,17,24,0);
_NAMES(fam11h_TOM2,0,"TOM2",0);
_RANGE(fam11h_NB_CFG,42,1,2,1,1,3,1,7,1,5,0);
_NAMES(fam11h_NB_CFG,0,"EnaPStateSpyCyc",0,"DisUsSysMgtReqToNcHt","EnableCf8ExtCfg",0,"DisOrderRdRsp",0,"EnConvertToNonIsoc",0);
_RANGE(fam11h_ProcessorNameString0,64,0);
_NAMES(fam11h_ProcessorNameString0,"CpuNameString");
_RANGE(fam11h_ProcessorNameString1,64,0);
_NAMES(fam11h_ProcessorNameString1,"CpuNameString");
_RANGE(fam11h_ProcessorNameString2,64,0);
_NAMES(fam11h_ProcessorNameString2,"CpuNameString");
_RANGE(fam11h_ProcessorNameString3,64,0);
_NAMES(fam11h_ProcessorNameString3,"CpuNameString");
_RANGE(fam11h_ProcessorNameString4,64,0);
_NAMES(fam11h_ProcessorNameString4,"CpuNameString");
_RANGE(fam11h_ProcessorNameString5,64,0);
_NAMES(fam11h_ProcessorNameString5,"CpuNameString");
_RANGE(fam11h_MC0_CTL_MASK,1,1,1,1,1,1,1,57,0);
_NAMES(fam11h_MC0_CTL_MASK,"ECCI","ECCM","DECC","DMTP","DSTP","L1TP","L2TP",0);
_RANGE(fam11h_MC1_CTL_MASK,1,1,1,1,1,1,1,2,1,54,0);
_NAMES(fam11h_MC1_CTL_MASK,"ECCI","ECCM","IDP","IMTP","ISTP","L1TP","L2TP",0,"RDDE",0);
_RANGE(fam11h_MC2_CTL_MASK,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,44,0);
_NAMES(fam11h_MC2_CTL_MASK,"S_RDE_HP","S_RDE_TLB","S_RDE_ALL","S_ECC1_TLB","S_ECC1_HP","S_ECCM_TLB","S_ECCM_HP","L2T_PAR_ICDC","L2T_PAR_TLB","L2_PAR_SNP","L2_PAR_CPB","L2_PAR_SCR","L2D_ECC1_TLB","L2D_ECC1_SNP","L2D_ECC1_CPB","L2D_ECCM_TLB","L2D_ECCM_SNP","L2D_ECCM_CPB","L2T_ECC1_SCR","L2T_ECCM_SCR",0);
_RANGE(fam11h_MC3_CTL_MASK,1,1,62,0);
_NAMES(fam11h_MC3_CTL_MASK,"S_RDE_L","S_RDE_S",0);
_RANGE(fam11h_MC4_CTL_MASK,2,1,2,1,2,1,1,1,1,1,1,2,1,1,1,1,5,1,1,1,36,0);
_NAMES(fam11h_MC4_CTL_MASK,0,"CrcErr0En",0,"SyncPkt0En",0,"MstrAbrtEn","TgtAbrtEn",0,"AtomicRMWEn","WDTRptEn","DevErrEn",0,"HtProtEn","HtDataEn",0,"RtryHt0En",0,"McaUsPwDatErrEn",0,"TblWlkDatErrEn",0);
_RANGE(fam11h_SMI_ON_IO_TRAP_0,32,24,5,1,1,1,0);
_NAMES(fam11h_SMI_ON_IO_TRAP_0,"SmiAddr","SmiMask",0,"ConfigSmi","SmiOnWrEn","SmiOnRdEn");
_RANGE(fam11h_SMI_ON_IO_TRAP_1,32,24,5,1,1,1,0);
_NAMES(fam11h_SMI_ON_IO_TRAP_1,"SmiAddr","SmiMask",0,"ConfigSmi","SmiOnWrEn","SmiOnRdEn");
_RANGE(fam11h_SMI_ON_IO_TRAP_2,32,24,5,1,1,1,0);
_NAMES(fam11h_SMI_ON_IO_TRAP_2,"SmiAddr","SmiMask",0,"ConfigSmi","SmiOnWrEn","SmiOnRdEn");
_RANGE(fam11h_SMI_ON_IO_TRAP_3,32,24,5,1,1,1,0);
_NAMES(fam11h_SMI_ON_IO_TRAP_3,"SmiAddr","SmiMask",0,"ConfigSmi","SmiOnWrEn","SmiOnRdEn");
_RANGE(fam11h_SMI_ON_IO_TRAP_CTL_STS,1,1,1,1,1,1,1,1,7,1,48,0);
_NAMES(fam11h_SMI_ON_IO_TRAP_CTL_STS,0,"SmiEn_0",0,"SmiEn_1",0,"SmiEn_2",0,"SmiEn_3",0,"IoTrapEn",0);
_RANGE(fam11h_IntPendingMessage,16,8,1,1,1,1,1,35,0);
_NAMES(fam11h_IntPendingMessage,"IOMsgAddr","IOMsgData","IntrPndMsgDis","IntrPndMsg","IORd","SmiOnCmpHalt","C1eOnCmpHalt",0);
_RANGE(fam11h_SmiTriggerIoCycle,16,8,1,1,1,37,0);
_NAMES(fam11h_SmiTriggerIoCycle,"IoPortAddress","IoData",0,"IoCycleEn","IoRd",0);
_RANGE(fam11h_MmioConfigBase,1,1,4,14,20,24,0);
_NAMES(fam11h_MmioConfigBase,"Enable",0,"BusRange",0,"MmiocCfgBaseAddr",0);
_RANGE(fam11h_BISTresults,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,32,0);
_NAMES(fam11h_BISTresults,"ICFT","ICST","ICTLB2","BTA","BSA","ICD","PDA","BH","ICTLB1","ICLRU","BSR","DCD","DCECC","DCTLB1","DCT","DCTLB2","DCLRU","FPCR","FPRR","FPRQ",0,"ROBD","L2D","L2T","WDB","VDB","L2LRU","FF","PDC",0,"MC",0);
_RANGE(fam11h_PstateCurrentLimit,3,1,3,57,0);
_NAMES(fam11h_PstateCurrentLimit,"CurPstateLimit",0,"PstateMaxVal",0);
_RANGE(fam11h_PstateControl,3,61,0);
_NAMES(fam11h_PstateControl,"PstateCmd",0);
_RANGE(fam11h_PstateStatus,3,61,0);
_NAMES(fam11h_PstateStatus,"CurPstate",0);
_RANGE(fam11h_Pstate0,6,3,7,16,8,2,21,1,0);
_NAMES(fam11h_Pstate0,"CpuFid","CpuDid","CpuVid",0,"IddValue","IddDiv",0,"PstateEn");
_RANGE(fam11h_Pstate1,6,3,7,16,8,2,21,1,0);
_NAMES(fam11h_Pstate1,"CpuFid","CpuDid","CpuVid",0,"IddValue","IddDiv",0,"PstateEn");
_RANGE(fam11h_Pstate2,6,3,7,16,8,2,21,1,0);
_NAMES(fam11h_Pstate2,"CpuFid","CpuDid","CpuVid",0,"IddValue","IddDiv",0,"PstateEn");
_RANGE(fam11h_Pstate3,6,3,7,16,8,2,21,1,0);
_NAMES(fam11h_Pstate3,"CpuFid","CpuDid","CpuVid",0,"IddValue","IddDiv",0,"PstateEn");
_RANGE(fam11h_Pstate4,6,3,7,16,8,2,21,1,0);
_NAMES(fam11h_Pstate4,"CpuFid","CpuDid","CpuVid",0,"IddValue","IddDiv",0,"PstateEn");
_RANGE(fam11h_Pstate5,6,3,7,16,8,2,21,1,0);
_NAMES(fam11h_Pstate5,"CpuFid","CpuDid","CpuVid",0,"IddValue","IddDiv",0,"PstateEn");
_RANGE(fam11h_Pstate6,6,3,7,16,8,2,21,1,0);
_NAMES(fam11h_Pstate6,"CpuFid","CpuDid","CpuVid",0,"IddValue","IddDiv",0,"PstateEn");
_RANGE(fam11h_Pstate7,6,3,7,16,8,2,21,1,0);
_NAMES(fam11h_Pstate7,"CpuFid","CpuDid","CpuVid",0,"IddValue","IddDiv",0,"PstateEn");
_RANGE(fam11h_COFVIDcontrol,6,3,7,3,45,0);
_NAMES(fam11h_COFVIDcontrol,"CpuFid","CpuDid","CpuVid","PstateId",0);
_RANGE(fam11h_COFVIDstatus,6,3,7,3,6,7,3,7,7,6,1,3,5,0);
_NAMES(fam11h_COFVIDstatus,"CurCpuFid","CurCpuDid","CurCpuVid","CurPstate",0,"CurNbVid","StartupPstate","MaxVid","MinVid","MainPllOpFreqIdMax",0,"CurPstateLimit",0);
_RANGE(fam11h_SMM_BASE,32,32,0);
_NAMES(fam11h_SMM_BASE,"SMM_BASE",0);
_RANGE(fam11h_SMMAddr,17,23,24,0);
_NAMES(fam11h_SMMAddr,0,"TSegBase",0);
_RANGE(fam11h_SMMMask,1,1,1,1,1,1,2,3,1,3,2,23,24,0);
_NAMES(fam11h_SMMMask,"AValid","TValid","AClose","TClose","AMTypeIoWc","TMTypeIoWc",0,"AMTypeDram",0,"TMTypeDram",0,"TSegMask",0);
_RANGE(fam11h_VM_CR,1,1,1,1,1,59,0);
_NAMES(fam11h_VM_CR,"dpd","r_init","dis_a20m","Lock","Svme_Disable",0);
_RANGE(fam11h_IGNNE,1,63,0);
_NAMES(fam11h_IGNNE,"IGNNE",0);
_RANGE(fam11h_VM_HSAVE_PA,64,0);
_NAMES(fam11h_VM_HSAVE_PA,"VM_HSAVE_PA");
_RANGE(fam11h_OSVW_ID_Length,16,48,0);
_NAMES(fam11h_OSVW_ID_Length,"OSVW_ID_Length",0);
_RANGE(fam11h_OsvwStatus,64,0);
_NAMES(fam11h_OsvwStatus,"OsvwStatusBits");
_RANGE(fam11h_DC_CFG,8,1,4,1,1,1,48,0);
_NAMES(fam11h_DC_CFG,0,"DIS_CLR_WBTOL2_SMC_HIT",0,"DIS_HW_PF",0,"DIS_PF_HW_FOR_SW",0);
_RANGE(fam11h_BU_CFG,48,1,15,0);
_NAMES(fam11h_BU_CFG,0,"WbEnhWsbDis",0);

struct reg_spec fam11h_spec [] = {
	_SPEC(0x0000, LSMCAaddr, "load-store MCA address", fam11h_),
	_SPEC(0x0001, LSMCAstatus, "load-store MCA status", fam11h_),
	_SPEC(0x0010, TSC, "time-stamp counter", fam11h_),
	_SPEC(0x001b, APIC_BASE, "APIC base address", fam11h_),
	_SPEC(0x002a, EBL_CR_POWERON, "cluster ID", fam11h_),
	_SPEC(0x008b, PATCH_LEVEL, "microcode patch level", fam11h_),
	_SPEC(0x00fe, MTRRcap, "MTRR capabilities", fam11h_),
	_SPEC(0x0174, SYSENTER_CS, "SYSENTER/SYSEXIT code segment selector", fam11h_),
	_SPEC(0x0175, SYSENTER_ESP, "SYSENTER/SYSEXIT stack pointer", fam11h_),
	_SPEC(0x0176, SYSENTER_EIP, "SYSENTER/SYSEXIT instruction pointer", fam11h_),
	_SPEC(0x0179, MCG_CAP, "global MC capabilities", fam11h_),
	_SPEC(0x017a, MCG_STAT, "global MC status", fam11h_),
	_SPEC(0x017b, MCG_CTL, "global MC control", fam11h_),
	_SPEC(0x01d9, DBG_CTL_MSR, "debug control", fam11h_),
	_SPEC(0x01db, BR_FROM, "last branch from IP", fam11h_),
	_SPEC(0x01dc, BR_TO, "last branch to IP", fam11h_),
	_SPEC(0x01dd, LastExceptionFromIP, "last exception from IP", fam11h_),
	_SPEC(0x01de, LastExceptionToIP, "last exception to IP", fam11h_),
	_SPEC(0x0200, MTRRphysBase0, "base of variable-size MTRR (0)", fam11h_),
	_SPEC(0x0201, MTRRphysMask0, "mask of variable-size MTRR (0)", fam11h_),
	_SPEC(0x0202, MTRRphysBase1, "base of variable-size MTRR (1)", fam11h_),
	_SPEC(0x0203, MTRRphysMask1, "mask of variable-size MTRR (1)", fam11h_),
	_SPEC(0x0204, MTRRphysBase2, "base of variable-size MTRR (2)", fam11h_),
	_SPEC(0x0205, MTRRphysMask2, "mask of variable-size MTRR (2)", fam11h_),
	_SPEC(0x0206, MTRRphysBase3, "base of variable-size MTRR (3)", fam11h_),
	_SPEC(0x0207, MTRRphysMask3, "mask of variable-size MTRR (3)", fam11h_),
	_SPEC(0x0208, MTRRphysBase4, "base of variable-size MTRR (4)", fam11h_),
	_SPEC(0x0209, MTRRphysMask4, "mask of variable-size MTRR (4)", fam11h_),
	_SPEC(0x020a, MTRRphysBase5, "base of variable-size MTRR (5)", fam11h_),
	_SPEC(0x020b, MTRRphysMask5, "mask of variable-size MTRR (5)", fam11h_),
	_SPEC(0x020c, MTRRphysBase6, "base of variable-size MTRR (6)", fam11h_),
	_SPEC(0x020d, MTRRphysMask6, "mask of variable-size MTRR (6)", fam11h_),
	_SPEC(0x020e, MTRRphysBase7, "base of variable-size MTRR (7)", fam11h_),
	_SPEC(0x020f, MTRRphysMask7, "mask of variable-size MTRR (7)", fam11h_),
	_SPEC(0x0250, MTRRfix64K_00000, "fixed range MTRR", fam11h_),
	_SPEC(0x0258, MTRRfix16K_80000, "fixed range MTRR", fam11h_),
	_SPEC(0x0259, MTRRfix16K_A0000, "fixed range MTRR", fam11h_),
	_SPEC(0x0268, MTRRfix4K_C0000, "fixed range MTRR", fam11h_),
	_SPEC(0x0269, MTRRfix4K_C8000, "fixed range MTRR", fam11h_),
	_SPEC(0x026a, MTRRfix4K_D0000, "fixed range MTRR", fam11h_),
	_SPEC(0x026b, MTRRfix4K_D8000, "fixed range MTRR", fam11h_),
	_SPEC(0x026c, MTRRfix4K_E0000, "fixed range MTRR", fam11h_),
	_SPEC(0x026d, MTRRfix4K_E8000, "fixed range MTRR", fam11h_),
	_SPEC(0x026e, MTRRfix4K_F0000, "fixed range MTRR", fam11h_),
	_SPEC(0x026f, MTRRfix4K_F8000, "fixed range MTRR", fam11h_),
	_SPEC(0x0277, PAT, "page attribute table", fam11h_),
	_SPEC(0x02ff, MTRRdefType, "MTRR default memory type", fam11h_),
	_SPEC(0x0400, MC0_CTL, "data cache MC control", fam11h_),
	_SPEC(0x0401, MC0_STATUS, "data cache MC status", fam11h_),
	_SPEC(0x0402, MC0_ADDR, "data cache MC address", fam11h_),
	_SPEC(0x0403, MC0_MISC, "data cache MC miscellaneous", fam11h_),
	_SPEC(0x0404, MC1_CTL, "instruction cache MC control", fam11h_),
	_SPEC(0x0405, MC1_STATUS, "instruction cache MC status", fam11h_),
	_SPEC(0x0406, MC1_ADDR, "instruction cache MC address", fam11h_),
	_SPEC(0x0407, MC1_MISC, "instruction cache MC miscellaneous", fam11h_),
	_SPEC(0x0408, MC2_CTL, "bus unit MC control", fam11h_),
	_SPEC(0x0409, MC2_STATUS, "bus unit MC status", fam11h_),
	_SPEC(0x040a, MC2_ADDR, "bus unit MC address register", fam11h_),
	_SPEC(0x040b, MC2_MISC, "bus unit MC miscellaneous", fam11h_),
	_SPEC(0x040c, MC3_CTL, "load store unit MC control", fam11h_),
	_SPEC(0x040d, MC3_STATUS, "load store unit MC status", fam11h_),
	_SPEC(0x040e, MC3_ADDR, "load store unit MC address", fam11h_),
	_SPEC(0x040f, MC3_MISC, "load store unit MC miscellaneous", fam11h_),
	_SPEC(0x0410, MC4_CTL, "northbridge MC control", fam11h_),
	_SPEC(0x0411, MC4_STATUS, "northbridge MC status", fam11h_),
	_SPEC(0x0412, MC4_ADDR, "northbridge MC address", fam11h_),
	_SPEC(0xc0000080, EFER, "extended feature enable", fam11h_),
	_SPEC(0xc0000081, STAR, "SYSCALL target address", fam11h_),
	_SPEC(0xc0000082, STAR64, "long mode SYSCALL target address", fam11h_),
	_SPEC(0xc0000083, STARCOMPAT, "compat mode SYSCALL target address", fam11h_),
	_SPEC(0xc0000084, SYSCALL_FLAG_MASK, "SYSCALL flag mask", fam11h_),
	_SPEC(0xc0000100, FS_BASE, "FS base", fam11h_),
	_SPEC(0xc0000101, GS_BASE, "GS base", fam11h_),
	_SPEC(0xc0000102, KernelGSbase, "kernel GS base", fam11h_),
	_SPEC(0xc0000103, TSC_AUX, "auxiliary time stamp counter data", fam11h_),
	_SPEC(0xc0010000, PERF_CTL0, "performance event select (0)", fam11h_),
	_SPEC(0xc0010001, PERF_CTL1, "performance event select (1)", fam11h_),
	_SPEC(0xc0010002, PERF_CTL2, "performance event select (2)", fam11h_),
	_SPEC(0xc0010003, PERF_CTL3, "performance event select (3)", fam11h_),
	_SPEC(0xc0010004, PERF_CTR0, "performance event counter (0)", fam11h_),
	_SPEC(0xc0010005, PERF_CTR1, "performance event counter (1)", fam11h_),
	_SPEC(0xc0010006, PERF_CTR2, "performance event counter (2)", fam11h_),
	_SPEC(0xc0010007, PERF_CTR3, "performance event counter (3)", fam11h_),
	_SPEC(0xc0010010, SYS_CFG, "system configuration", fam11h_),
	_SPEC(0xc0010015, HWCR, "hardware configuration", fam11h_),
	_SPEC(0xc0010016, IORR_BASE0, "base of variable I/O range (0)", fam11h_),
	_SPEC(0xc0010017, IORR_MASK0, "mask of variable I/O range (0)", fam11h_),
	_SPEC(0xc0010018, IORR_BASE1, "base of variable I/O range (1)", fam11h_),
	_SPEC(0xc0010019, IORR_MASK1, "mask of variable I/O range (1)", fam11h_),
	_SPEC(0xc001001a, TOP_MEM, "top of memory address", fam11h_),
	_SPEC(0xc001001d, TOM2, "second top of memory address", fam11h_),
	_SPEC(0xc001001f, NB_CFG, "northbridge configuration", fam11h_),
	_SPEC(0xc0010030, ProcessorNameString0, "processor name string (0)", fam11h_),
	_SPEC(0xc0010031, ProcessorNameString1, "processor name string (1)", fam11h_),
	_SPEC(0xc0010032, ProcessorNameString2, "processor name string (2)", fam11h_),
	_SPEC(0xc0010033, ProcessorNameString3, "processor name string (3)", fam11h_),
	_SPEC(0xc0010034, ProcessorNameString4, "processor name string (4)", fam11h_),
	_SPEC(0xc0010035, ProcessorNameString5, "processor name string (5)", fam11h_),
	_SPEC(0xc0010044, MC0_CTL_MASK, "data cache MC control mask", fam11h_),
	_SPEC(0xc0010045, MC1_CTL_MASK, "instruction cache MC control mask", fam11h_),
	_SPEC(0xc0010046, MC2_CTL_MASK, "bus unit MC control mask", fam11h_),
	_SPEC(0xc0010047, MC3_CTL_MASK, "load store unit MC control mask", fam11h_),
	_SPEC(0xc0010048, MC4_CTL_MASK, "northbridge MC control mask", fam11h_),
	_SPEC(0xc0010050, SMI_ON_IO_TRAP_0, "IO trap address (0)", fam11h_),
	_SPEC(0xc0010051, SMI_ON_IO_TRAP_1, "IO trap address (1)", fam11h_),
	_SPEC(0xc0010052, SMI_ON_IO_TRAP_2, "IO trap address (2)", fam11h_),
	_SPEC(0xc0010053, SMI_ON_IO_TRAP_3, "IO trap address (3)", fam11h_),
	_SPEC(0xc0010054, SMI_ON_IO_TRAP_CTL_STS, "IO trap control", fam11h_),
	_SPEC(0xc0010055, IntPendingMessage, "interrupt pending and CMP-halt", fam11h_),
	_SPEC(0xc0010056, SmiTriggerIoCycle, "SMI trigger IO cycle", fam11h_),
	_SPEC(0xc0010058, MmioConfigBase, "MMIO configuration base address", fam11h_),
	_SPEC(0xc0010060, BISTresults, "BIST results register", fam11h_),
	_SPEC(0xc0010061, PstateCurrentLimit, "P-state current limit", fam11h_),
	_SPEC(0xc0010062, PstateControl, "P-state control", fam11h_),
	_SPEC(0xc0010063, PstateStatus, "P-state status", fam11h_),
	_SPEC(0xc0010064, Pstate0, "P-state 0", fam11h_),
	_SPEC(0xc0010065, Pstate1, "P-state 1", fam11h_),
	_SPEC(0xc0010066, Pstate2, "P-state 2", fam11h_),
	_SPEC(0xc0010067, Pstate3, "P-state 3", fam11h_),
	_SPEC(0xc0010068, Pstate4, "P-state 4", fam11h_),
	_SPEC(0xc0010069, Pstate5, "P-state 5", fam11h_),
	_SPEC(0xc001006a, Pstate6, "P-state 6", fam11h_),
	_SPEC(0xc001006b, Pstate7, "P-state 7", fam11h_),
	_SPEC(0xc0010070, COFVIDcontrol, "COFVID control", fam11h_),
	_SPEC(0xc0010071, COFVIDstatus, "COFVID status", fam11h_),
	_SPEC(0xc0010111, SMM_BASE, "SMM base address", fam11h_),
	_SPEC(0xc0010112, SMMAddr, "SMM TSeg base address", fam11h_),
	_SPEC(0xc0010113, SMMMask, "SMM Tseg mask", fam11h_),
	_SPEC(0xc0010114, VM_CR, "virtual machine control", fam11h_),
	_SPEC(0xc0010115, IGNNE, "IGNNE", fam11h_),
	_SPEC(0xc0010117, VM_HSAVE_PA, "virtual machine host save physical address", fam11h_),
	_SPEC(0xc0010140, OSVW_ID_Length, "OS visible work-around ID length", fam11h_),
	_SPEC(0xc0010141, OsvwStatus, "OS visible work-around status", fam11h_),
	_SPEC(0xc0011022, DC_CFG, "data cache configuration register", fam11h_),
	_SPEC(0xc0011023, BU_CFG, "bus unit configuration register", fam11h_),
	{0, NULL, NULL, NULL, NULL},
};

#endif /* fam11h_h */
