/*
 * Licensed under the terms of the GNU GENERAL PUBLIC LICENSE version 2.
 * See file COPYING for details.
 */

#ifndef fam15h_h
#define fam15h_h

#include "../msr.h"

_RANGE(fam15h_LSMCAaddr,64,0);
_NAMES(fam15h_LSMCAaddr,"ADDR");
_RANGE(fam15h_LSMCAstatus,16,5,15,4,3,1,1,12,1,1,1,1,1,1,1,0);
_NAMES(fam15h_LSMCAstatus,"ErrorCode","ErrorCodeExt",0,"Way",0,"Poison","Deferred",0,"PCC","AddrV","MiscV","En","UC","Overflow","Val");
_RANGE(fam15h_TSC,64,0);
_NAMES(fam15h_TSC,"TSC");
_RANGE(fam15h_APIC_BASE,8,1,1,1,1,28,24,0);
_NAMES(fam15h_APIC_BASE,0,"BSC",0,"Apicx2En","ApicEn","ApicBar",0);
_RANGE(fam15h_EBL_CR_POWERON,16,2,46,0);
_NAMES(fam15h_EBL_CR_POWERON,0,"ClusterID",0);
_RANGE(fam15h_PATCH_LEVEL,32,32,0);
_NAMES(fam15h_PATCH_LEVEL,"PATCH_LEVEL",0);
_RANGE(fam15h_MPERF,64,0);
_NAMES(fam15h_MPERF,"MPERF");
_RANGE(fam15h_APERF,64,0);
_NAMES(fam15h_APERF,"APERF");
_RANGE(fam15h_MTRRcap,8,1,1,1,53,0);
_NAMES(fam15h_MTRRcap,"MtrrCapVCnt","MtrrCapFix",0,"MtrrCapWc",0);
_RANGE(fam15h_SYSENTER_CS,16,48,0);
_NAMES(fam15h_SYSENTER_CS,"SYSENTER_CS",0);
_RANGE(fam15h_SYSENTER_ESP,32,32,0);
_NAMES(fam15h_SYSENTER_ESP,"SYSENTER_ESP",0);
_RANGE(fam15h_SYSENTER_EIP,32,32,0);
_NAMES(fam15h_SYSENTER_EIP,"SYSENTER_EIP",0);
_RANGE(fam15h_MCG_CAP,8,1,55,0);
_NAMES(fam15h_MCG_CAP,"Count","MCG_CTL_P",0);
_RANGE(fam15h_MCG_STAT,1,1,1,61,0);
_NAMES(fam15h_MCG_STAT,"RIPV","EIPV","MCIP",0);
_RANGE(fam15h_MCG_CTL,1,1,1,1,1,1,1,57,0);
_NAMES(fam15h_MCG_CTL,"LS","IF","CU",0,"NB","EX","FP",0);
_RANGE(fam15h_DBG_CTL_MSR,1,1,1,1,1,1,58,0);
_NAMES(fam15h_DBG_CTL_MSR,"LBR","BTF","PB0","PB1","PB2","PB3",0);
_RANGE(fam15h_BR_FROM,64,0);
_NAMES(fam15h_BR_FROM,"LastBranchFromIP");
_RANGE(fam15h_BR_TO,64,0);
_NAMES(fam15h_BR_TO,"LastBranchToIP");
_RANGE(fam15h_LastExceptionFromIP,64,0);
_NAMES(fam15h_LastExceptionFromIP,"LastIntFromIP");
_RANGE(fam15h_LastExceptionToIP,64,0);
_NAMES(fam15h_LastExceptionToIP,"LastIntToIP");
_RANGE(fam15h_MTRRphysBase0,3,9,36,16,0);
_NAMES(fam15h_MTRRphysBase0,"MemType",0,"PhyBase",0);
_RANGE(fam15h_MTRRphysMask0,11,1,36,16,0);
_NAMES(fam15h_MTRRphysMask0,0,"Valid","PhysMask",0);
_RANGE(fam15h_MTRRphysBase1,3,9,36,16,0);
_NAMES(fam15h_MTRRphysBase1,"MemType",0,"PhyBase",0);
_RANGE(fam15h_MTRRphysMask1,11,1,36,16,0);
_NAMES(fam15h_MTRRphysMask1,0,"Valid","PhysMask",0);
_RANGE(fam15h_MTRRphysBase2,3,9,36,16,0);
_NAMES(fam15h_MTRRphysBase2,"MemType",0,"PhyBase",0);
_RANGE(fam15h_MTRRphysMask2,11,1,36,16,0);
_NAMES(fam15h_MTRRphysMask2,0,"Valid","PhysMask",0);
_RANGE(fam15h_MTRRphysBase3,3,9,36,16,0);
_NAMES(fam15h_MTRRphysBase3,"MemType",0,"PhyBase",0);
_RANGE(fam15h_MTRRphysMask3,11,1,36,16,0);
_NAMES(fam15h_MTRRphysMask3,0,"Valid","PhysMask",0);
_RANGE(fam15h_MTRRphysBase4,3,9,36,16,0);
_NAMES(fam15h_MTRRphysBase4,"MemType",0,"PhyBase",0);
_RANGE(fam15h_MTRRphysMask4,11,1,36,16,0);
_NAMES(fam15h_MTRRphysMask4,0,"Valid","PhysMask",0);
_RANGE(fam15h_MTRRphysBase5,3,9,36,16,0);
_NAMES(fam15h_MTRRphysBase5,"MemType",0,"PhyBase",0);
_RANGE(fam15h_MTRRphysMask5,11,1,36,16,0);
_NAMES(fam15h_MTRRphysMask5,0,"Valid","PhysMask",0);
_RANGE(fam15h_MTRRphysBase6,3,9,36,16,0);
_NAMES(fam15h_MTRRphysBase6,"MemType",0,"PhyBase",0);
_RANGE(fam15h_MTRRphysMask6,11,1,36,16,0);
_NAMES(fam15h_MTRRphysMask6,0,"Valid","PhysMask",0);
_RANGE(fam15h_MTRRphysBase7,3,9,36,16,0);
_NAMES(fam15h_MTRRphysBase7,"MemType",0,"PhyBase",0);
_RANGE(fam15h_MTRRphysMask7,11,1,36,16,0);
_NAMES(fam15h_MTRRphysMask7,0,"Valid","PhysMask",0);
_RANGE(fam15h_MTRRfix64K_00000,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,0);
_NAMES(fam15h_MTRRfix64K_00000,"0xxxxMemType","0xxxxWrDram","0xxxxRdDram",0,"1xxxxMemType","1xxxxWrDram","1xxxxRdDram",0,"2xxxxMemType","2xxxxWrDram","2xxxxRdDram",0,"3xxxxMemType","3xxxxWrDram","3xxxxRdDram",0,"4xxxxMemType","4xxxxWrDram","4xxxxRdDram",0,"5xxxxMemType","5xxxxWrDram","5xxxxRdDram",0,"6xxxxMemType","6xxxxWrDram","6xxxxRdDram",0,"7xxxxMemType","7xxxxWrDram","7xxxxRdDram",0);
_RANGE(fam15h_MTRRfix16K_80000,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,0);
_NAMES(fam15h_MTRRfix16K_80000,"80xxxMemType","80xxxWrDram","80xxxRdDram",0,"84xxxMemType","84xxxWrDram","84xxxRdDram",0,"88xxxMemType","88xxxWrDram","88xxxRdDram",0,"8CxxxMemType","8CxxxWrDram","8CxxxRdDram",0,"90xxxMemType","90xxxWrDram","90xxxRdDram",0,"94xxxMemType","94xxxWrDram","94xxxRdDram",0,"98xxxMemType","98xxxWrDram","98xxxRdDram",0,"9CxxxMemType","9CxxxWrDram","9CxxxRdDram",0);
_RANGE(fam15h_MTRRfix16K_A0000,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,0);
_NAMES(fam15h_MTRRfix16K_A0000,"A0xxxMemType","A0xxxWrDram","A0xxxRdDram",0,"A4xxxMemType","A4xxxWrDram","A4xxxRdDram",0,"A8xxxMemType","A8xxxWrDram","A8xxxRdDram",0,"ACxxxMemType","ACxxxWrDram","ACxxxRdDram",0,"B0xxxMemType","B0xxxWrDram","B0xxxRdDram",0,"B4xxxMemType","B4xxxWrDram","B4xxxRdDram",0,"B8xxxMemType","B8xxxWrDram","B8xxxRdDram",0,"BCxxxMemType","BCxxxWrDram","BCxxxRdDram",0);
_RANGE(fam15h_MTRRfix4K_C0000,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,0);
_NAMES(fam15h_MTRRfix4K_C0000,"C0xxxMemType","C0xxxWrDram","C0xxxRdDram",0,"C1xxxMemType","C1xxxWrDram","C1xxxRdDram",0,"C2xxxMemType","C2xxxWrDram","C2xxxRdDram",0,"C3xxxMemType","C3xxxWrDram","C3xxxRdDram",0,"C4xxxMemType","C4xxxWrDram","C4xxxRdDram",0,"C5xxxMemType","C5xxxWrDram","C5xxxRdDram",0,"C6xxxMemType","C6xxxWrDram","C6xxxRdDram",0,"C7xxxMemType","C7xxxWrDram","C7xxxRdDram",0);
_RANGE(fam15h_MTRRfix4K_C8000,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,0);
_NAMES(fam15h_MTRRfix4K_C8000,"C8xxxMemType","C8xxxWrDram","C8xxxRdDram",0,"C9xxxMemType","C9xxxWrDram","C9xxxRdDram",0,"CAxxxMemType","CAxxxWrDram","CAxxxRdDram",0,"CBxxxMemType","CBxxxWrDram","CBxxxRdDram",0,"CCxxxMemType","CCxxxWrDram","CCxxxRdDram",0,"CDxxxMemType","CDxxxWrDram","CDxxxRdDram",0,"CExxxMemType","CExxxWrDram","CExxxRdDram",0,"CFxxxMemType","CFxxxWrDram","CFxxxRdDram",0);
_RANGE(fam15h_MTRRfix4K_D0000,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,0);
_NAMES(fam15h_MTRRfix4K_D0000,"D0xxxMemType","D0xxxWrDram","D0xxxRdDram",0,"D1xxxMemType","D1xxxWrDram","D1xxxRdDram",0,"D2xxxMemType","D2xxxWrDram","D2xxxRdDram",0,"D3xxxMemType","D3xxxWrDram","D3xxxRdDram",0,"D4xxxMemType","D4xxxWrDram","D4xxxRdDram",0,"D5xxxMemType","D5xxxWrDram","D5xxxRdDram",0,"D6xxxMemType","D6xxxWrDram","D6xxxRdDram",0,"D7xxxMemType","D7xxxWrDram","D7xxxRdDram",0);
_RANGE(fam15h_MTRRfix4K_D8000,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,0);
_NAMES(fam15h_MTRRfix4K_D8000,"D8xxxMemType","D8xxxWrDram","D8xxxRdDram",0,"D9xxxMemType","D9xxxWrDram","D9xxxRdDram",0,"DAxxxMemType","DAxxxWrDram","DAxxxRdDram",0,"DBxxxMemType","DBxxxWrDram","DBxxxRdDram",0,"DCxxxMemType","DCxxxWrDram","DCxxxRdDram",0,"DDxxxMemType","DDxxxWrDram","DDxxxRdDram",0,"DExxxMemType","DExxxWrDram","DExxxRdDram",0,"DFxxxMemType","DFxxxWrDram","DFxxxRdDram",0);
_RANGE(fam15h_MTRRfix4K_E0000,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,0);
_NAMES(fam15h_MTRRfix4K_E0000,"E0xxxMemType","E0xxxWrDram","E0xxxRdDram",0,"E1xxxMemType","E1xxxWrDram","E1xxxRdDram",0,"E2xxxMemType","E2xxxWrDram","E2xxxRdDram",0,"E3xxxMemType","E3xxxWrDram","E3xxxRdDram",0,"E4xxxMemType","E4xxxWrDram","E4xxxRdDram",0,"E5xxxMemType","E5xxxWrDram","E5xxxRdDram",0,"E6xxxMemType","E6xxxWrDram","E6xxxRdDram",0,"E7xxxMemType","E7xxxWrDram","E7xxxRdDram",0);
_RANGE(fam15h_MTRRfix4K_E8000,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,0);
_NAMES(fam15h_MTRRfix4K_E8000,"E8xxxMemType","E8xxxWrDram","E8xxxRdDram",0,"E9xxxMemType","E9xxxWrDram","E9xxxRdDram",0,"EAxxxMemType","EAxxxWrDram","EAxxxRdDram",0,"EBxxxMemType","EBxxxWrDram","EBxxxRdDram",0,"ECxxxMemType","ECxxxWrDram","ECxxxRdDram",0,"EDxxxMemType","EDxxxWrDram","EDxxxRdDram",0,"EExxxMemType","EExxxWrDram","EExxxRdDram",0,"EFxxxMemType","EFxxxWrDram","EFxxxRdDram",0);
_RANGE(fam15h_MTRRfix4K_F0000,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,0);
_NAMES(fam15h_MTRRfix4K_F0000,"F0xxxMemType","F0xxxWrDram","F0xxxRdDram",0,"F1xxxMemType","F1xxxWrDram","F1xxxRdDram",0,"F2xxxMemType","F2xxxWrDram","F2xxxRdDram",0,"F3xxxMemType","F3xxxWrDram","F3xxxRdDram",0,"F4xxxMemType","F4xxxWrDram","F4xxxRdDram",0,"F5xxxMemType","F5xxxWrDram","F5xxxRdDram",0,"F6xxxMemType","F6xxxWrDram","F6xxxRdDram",0,"F7xxxMemType","F7xxxWrDram","F7xxxRdDram",0);
_RANGE(fam15h_MTRRfix4K_F8000,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,0);
_NAMES(fam15h_MTRRfix4K_F8000,"F8xxxMemType","F8xxxWrDram","F8xxxRdDram",0,"F9xxxMemType","F9xxxWrDram","F9xxxRdDram",0,"FAxxxMemType","FAxxxWrDram","FAxxxRdDram",0,"FBxxxMemType","FBxxxWrDram","FBxxxRdDram",0,"FCxxxMemType","FCxxxWrDram","FCxxxRdDram",0,"FDxxxMemType","FDxxxWrDram","FDxxxRdDram",0,"FExxxMemType","FExxxWrDram","FExxxRdDram",0,"FFxxxMemType","FFxxxWrDram","FFxxxRdDram",0);
_RANGE(fam15h_PAT,3,5,3,5,3,5,3,5,3,5,3,5,3,5,3,5,0);
_NAMES(fam15h_PAT,"PA0MemType",0,"PA1MemType",0,"PA2MemType",0,"PA3MemType",0,"PA4MemType",0,"PA5MemType",0,"PA6MemType",0,"PA7MemType",0);
_RANGE(fam15h_MTRRdefType,8,2,1,1,52,0);
_NAMES(fam15h_MTRRdefType,"MemType",0,"MtrrDefTypeFixEn","MtrrDefTypeEn",0);
_RANGE(fam15h_MC0_CTL,1,1,1,1,1,1,1,1,1,1,54,0);
_NAMES(fam15h_MC0_CTL,"TagP","TLBP","DatP","LQP","SQP","SCBP","LineFillPoison","SRDE","IntErrType2","IntErrType1",0);
_RANGE(fam15h_MC0_STATUS,16,5,15,4,3,1,1,12,1,1,1,1,1,1,1,0);
_NAMES(fam15h_MC0_STATUS,"ErrorCode","ErrorCodeExt",0,"Way",0,"Poison","Deferred",0,"PCC","AddrV","MiscV","En","UC","Overflow","Val");
_RANGE(fam15h_MC0_ADDR,64,0);
_NAMES(fam15h_MC0_ADDR,"ADDR");
_RANGE(fam15h_MC0_MISC,24,8,12,4,1,2,1,10,1,1,0);
_NAMES(fam15h_MC0_MISC,0,"BlkPtr","ErrCnt",0,"Ovrflw",0,"CntEn",0,"CntP","Valid");
_RANGE(fam15h_MC1_CTL,2,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,40,0);
_NAMES(fam15h_MC1_CTL,0,"IDP","IMTP","ISTP","L2TP","L1TP","LineFillPoison",0,"SRDE",0,"PFBP","PQP",0,"BSRP","DEPRP","DEUOPQP","DEIBP","DPDBE","DFIFOE","L2TLBM","L1TLBM","IVP",0);
_RANGE(fam15h_MC1_STATUS,16,5,15,4,3,1,1,12,1,1,1,1,1,1,1,0);
_NAMES(fam15h_MC1_STATUS,"ErrorCode","ErrorCodeExt",0,"Way",0,"Poison","Deferred",0,"PCC","AddrV","MiscV","En","UC","Overflow","Val");
_RANGE(fam15h_MC1_ADDR,64,0);
_NAMES(fam15h_MC1_ADDR,"ADDR");
_RANGE(fam15h_MC1_MISC,24,8,12,4,1,2,1,10,1,1,0);
_NAMES(fam15h_MC1_MISC,0,"BlkPtr","ErrCnt",0,"Ovrflw",0,"CntEn",0,"CntP","Valid");
_RANGE(fam15h_MC2_CTL,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,49,0);
_NAMES(fam15h_MC2_CTL,"L2TagMultiHit","VbData","WcbData","WccData","WccAddr","PrqData","PrqAddr","FillData","PrbAddr","XabAddr","L2Prefetch","L2TlbData","L2Tag","RdData","L2TlbPoison",0);
_RANGE(fam15h_MC2_STATUS,16,5,3,4,8,4,3,1,1,1,1,8,2,1,1,1,1,1,1,1,0);
_NAMES(fam15h_MC2_STATUS,"ErrorCode","ErrorCodeExt",0,"Syndrome",0,"Way",0,"Poison","Deferred","UECC","CECC","Syndrome",0,"PCC","AddrV","MiscV","En","UC","Overflow","Val");
_RANGE(fam15h_MC2_ADDR,64,0);
_NAMES(fam15h_MC2_ADDR,"ADDR");
_RANGE(fam15h_MC2_MISC,24,8,12,4,1,2,1,10,1,1,0);
_NAMES(fam15h_MC2_MISC,0,"BlkPtr","ErrCnt",0,"Ovrflw",0,"CntEn",0,"CntP","Valid");
_RANGE(fam15h_MC3_CTL,64,0);
_NAMES(fam15h_MC3_CTL,0);
_RANGE(fam15h_MC3_STATUS,64,0);
_NAMES(fam15h_MC3_STATUS,0);
_RANGE(fam15h_MC3_ADDR,64,0);
_NAMES(fam15h_MC3_ADDR,0);
_RANGE(fam15h_MC3_MISC,64,0);
_NAMES(fam15h_MC3_MISC,0);
_RANGE(fam15h_MC4_CTL,1,1,3,3,1,1,1,1,1,1,1,1,1,1,1,4,1,1,1,1,1,3,1,32,0);
_NAMES(fam15h_MC4_CTL,"CECCEn","UECCEn","CrcErrEn","SyncPktEn","MstrAbrtEn","TgtAbrtEn","GartTblWkEn","AtomicRMWEn","WDTRptEn",0,"L3ArrayCorEn","L3ArrayUCEn","ProtEn","HtDataEn","DramParEn","RtryHtEn","CrcErrEn","SyncPktEn","McaUsPwDatErrEn","NbArrayParEn","TblWlkDatErrEn",0,"McaCpuDatErrEn",0);
_RANGE(fam15h_MC4_STATUS,16,5,3,8,4,4,1,1,2,1,1,1,8,1,1,1,1,1,1,1,1,1,0);
_NAMES(fam15h_MC4_STATUS,"ErrorCode","ErrorCodeExt",0,"Syndrome","ErrCoreId","Link","Scrub","SubLink","McaStatSubCache",0,"UECC","CECC","Syndrome",0,"ErrCoreIdVal","PCC","AddrV","MiscV","En","UC","Overflow","Val");
_RANGE(fam15h_MC4_ADDR,1,47,16,0);
_NAMES(fam15h_MC4_ADDR,0,"ErrAddr",0);
_RANGE(fam15h_MC4_MISC0,24,8,12,4,1,2,1,4,5,1,1,1,0);
_NAMES(fam15h_MC4_MISC0,0,"BlkPtr","ErrCnt",0,"Ovrflw","IntType","CntEn","LvtOffset",0,"Locked","CntP","Valid");
_RANGE(fam15h_MC5_CTL,1,1,1,1,1,1,1,1,1,1,1,1,1,51,0);
_NAMES(fam15h_MC5_CTL,0,"PICWAK","PLDAG","PLDEX","IDF","RETDISP","MAP","EX0PRF","EX1PRF","AG0PRF","AG1PRF","FRF","DE",0);
_RANGE(fam15h_MC5_STATUS,16,5,36,1,1,1,1,1,1,1,0);
_NAMES(fam15h_MC5_STATUS,"ErrorCode","ErrorCodeExt",0,"PCC","AddrV","MiscV","En","UC","Overflow","Val");
_RANGE(fam15h_MC5_ADDR,64,0);
_NAMES(fam15h_MC5_ADDR,"ADDR");
_RANGE(fam15h_MC5_MISC,24,8,12,4,1,2,1,10,1,1,0);
_NAMES(fam15h_MC5_MISC,0,"BlkPtr","ErrCnt",0,"Ovrflw",0,"CntEn",0,"CntP","Valid");
_RANGE(fam15h_MC6_CTL,1,1,1,1,1,1,58,0);
_NAMES(fam15h_MC6_CTL,"PRF","FreeList","Sched",0,"RetireQ","SRF",0);
_RANGE(fam15h_MC6_STATUS,16,5,36,1,1,1,1,1,1,1,0);
_NAMES(fam15h_MC6_STATUS,"ErrorCode","ErrorCodeExt",0,"PCC","AddrV","MiscV","En","UC","Overflow","Val");
_RANGE(fam15h_MC6_ADDR,64,0);
_NAMES(fam15h_MC6_ADDR,0);
_RANGE(fam15h_MC6_MISC,64,0);
_NAMES(fam15h_MC6_MISC,0);
_RANGE(fam15h_EFER,1,7,1,1,1,1,1,1,1,49,0);
_NAMES(fam15h_EFER,"SYSCALL",0,"LME",0,"LMA","NXE","SVME","LMSLE","FFXSE",0);
_RANGE(fam15h_STAR,32,16,16,0);
_NAMES(fam15h_STAR,"Target","SysCallSel","SysRetSel");
_RANGE(fam15h_STAR64,64,0);
_NAMES(fam15h_STAR64,"LSTAR");
_RANGE(fam15h_STARCOMPAT,64,0);
_NAMES(fam15h_STARCOMPAT,"CSTAR");
_RANGE(fam15h_SYSCALL_FLAG_MASK,32,32,0);
_NAMES(fam15h_SYSCALL_FLAG_MASK,"MASK",0);
_RANGE(fam15h_FS_BASE,64,0);
_NAMES(fam15h_FS_BASE,"FS_BASE");
_RANGE(fam15h_GS_BASE,64,0);
_NAMES(fam15h_GS_BASE,"GS_BASE");
_RANGE(fam15h_KernelGSbase,64,0);
_NAMES(fam15h_KernelGSbase,"KernelGSBase");
_RANGE(fam15h_TSC_AUX,32,32,0);
_NAMES(fam15h_TSC_AUX,"TscAux",0);
_RANGE(fam15h_TscRateMsr,32,32,0);
_NAMES(fam15h_TscRateMsr,"TscRateMsrFrac","TscRateMsrInt");
_RANGE(fam15h_LWP_CFG,1,1,1,1,1,1,1,24,1,8,8,16,0);
_NAMES(fam15h_LWP_CFG,0,"LwpVAL","LwpIRE","LwpBRE","LwpDME","LwpCNH","LwpRNH",0,"LwpInt","LwpCoreId","LwpVector",0);
_RANGE(fam15h_LWP_CBADDR,6,58,0);
_NAMES(fam15h_LWP_CBADDR,0,"LwpCbAddr");
_RANGE(fam15h_MC4_MISC1,24,8,12,4,1,2,1,4,5,1,1,1,0);
_NAMES(fam15h_MC4_MISC1,0,"BlkPtr","ErrCnt",0,"Ovrflw","IntType","CntEn","LvtOffset",0,"Locked","CntP","Valid");
_RANGE(fam15h_MC4_MISC2,24,8,12,4,1,2,1,4,5,1,1,1,0);
_NAMES(fam15h_MC4_MISC2,0,"BlkPtr","ErrCnt",0,"Ovrflw","IntType","CntEn","LvtOffset",0,"Locked","CntP","Valid");
_RANGE(fam15h_MC4_MISC3,64,0);
_NAMES(fam15h_MC4_MISC3,0);
_RANGE(fam15h_LEG_PERF_CTL0,8,8,2,1,1,1,1,1,1,8,4,4,2,22,0);
_NAMES(fam15h_LEG_PERF_CTL0,"EventSelect","UnitMask","OsUserMode","Edge",0,"Int",0,"En","Inv","CntMask","EventSelect",0,"HostGuestOnly",0);
_RANGE(fam15h_LEG_PERF_CTL1,8,8,2,1,1,1,1,1,1,8,4,4,2,22,0);
_NAMES(fam15h_LEG_PERF_CTL1,"EventSelect","UnitMask","OsUserMode","Edge",0,"Int",0,"En","Inv","CntMask","EventSelect",0,"HostGuestOnly",0);
_RANGE(fam15h_LEG_PERF_CTL2,8,8,2,1,1,1,1,1,1,8,4,4,2,22,0);
_NAMES(fam15h_LEG_PERF_CTL2,"EventSelect","UnitMask","OsUserMode","Edge",0,"Int",0,"En","Inv","CntMask","EventSelect",0,"HostGuestOnly",0);
_RANGE(fam15h_LEG_PERF_CTL3,8,8,2,1,1,1,1,1,1,8,4,4,2,22,0);
_NAMES(fam15h_LEG_PERF_CTL3,"EventSelect","UnitMask","OsUserMode","Edge",0,"Int",0,"En","Inv","CntMask","EventSelect",0,"HostGuestOnly",0);
_RANGE(fam15h_LEG_PERF_CTR0,48,16,0);
_NAMES(fam15h_LEG_PERF_CTR0,"CTR",0);
_RANGE(fam15h_LEG_PERF_CTR1,48,16,0);
_NAMES(fam15h_LEG_PERF_CTR1,"CTR",0);
_RANGE(fam15h_LEG_PERF_CTR2,48,16,0);
_NAMES(fam15h_LEG_PERF_CTR2,"CTR",0);
_RANGE(fam15h_LEG_PERF_CTR3,48,16,0);
_NAMES(fam15h_LEG_PERF_CTR3,"CTR",0);
_RANGE(fam15h_SYS_CFG,16,1,1,1,1,1,1,1,41,0);
_NAMES(fam15h_SYS_CFG,0,"ChxToDirtyDis",0,"MtrrFixDramEn","MtrrFixDramModeEn","MtrrVarDramEn","MtrrTom2En","Tom2ForceMemTypeWB",0);
_RANGE(fam15h_HWCR,1,2,1,1,3,1,1,1,1,1,1,1,2,1,1,1,1,2,1,1,1,1,37,0);
_NAMES(fam15h_HWCR,"SmmLock",0,"TlbCacheDis","INVDWBINVD",0,"IgnneEm","MonMwaitDis","MonMwaitUserEn",0,"HltXSpCycEn","SmiSpCycDis","RsmSpCycDis",0,"Wrap32Dis","McStatusWrEn",0,"IoCfgGpFault",0,"ForceRdWrSzPrb","TscFreqSel","CpbDis","EffFreqCntMwait",0);
_RANGE(fam15h_IORR_BASE0,3,1,1,7,36,16,0);
_NAMES(fam15h_IORR_BASE0,0,"WrMem","RdMem",0,"PhyBase",0);
_RANGE(fam15h_IORR_MASK0,11,1,36,16,0);
_NAMES(fam15h_IORR_MASK0,0,"Valid","PhyMask",0);
_RANGE(fam15h_IORR_BASE1,3,1,1,7,36,16,0);
_NAMES(fam15h_IORR_BASE1,0,"WrMem","RdMem",0,"PhyBase",0);
_RANGE(fam15h_IORR_MASK1,11,1,36,16,0);
_NAMES(fam15h_IORR_MASK1,0,"Valid","PhyMask",0);
_RANGE(fam15h_TOP_MEM,23,25,16,0);
_NAMES(fam15h_TOP_MEM,0,"TOM",0);
_RANGE(fam15h_TOM2,23,25,16,0);
_NAMES(fam15h_TOM2,0,"TOM2",0);
_RANGE(fam15h_NB_CFG,9,1,1,20,1,4,1,8,1,1,3,1,3,1,9,0);
_NAMES(fam15h_NB_CFG,0,"DisRefUseFreeBuf","DisXdsBypass",0,"DisCohLdtCfg",0,"DisDatMsk",0,"DisUsSysMgtReqToNcHt","EnableCf8ExtCfg",0,"DisOrderRdRsp",0,"InitApicIdCpuIdLo",0);
_RANGE(fam15h_MCEredirection,8,1,1,54,0);
_NAMES(fam15h_MCEredirection,"RedirVector","RedirVecEn","RedirSmiEn",0);
_RANGE(fam15h_ProcessorNameString0,64,0);
_NAMES(fam15h_ProcessorNameString0,"CpuNameString");
_RANGE(fam15h_ProcessorNameString1,64,0);
_NAMES(fam15h_ProcessorNameString1,"CpuNameString");
_RANGE(fam15h_ProcessorNameString2,64,0);
_NAMES(fam15h_ProcessorNameString2,"CpuNameString");
_RANGE(fam15h_ProcessorNameString3,64,0);
_NAMES(fam15h_ProcessorNameString3,"CpuNameString");
_RANGE(fam15h_ProcessorNameString4,64,0);
_NAMES(fam15h_ProcessorNameString4,"CpuNameString");
_RANGE(fam15h_ProcessorNameString5,64,0);
_NAMES(fam15h_ProcessorNameString5,"CpuNameString");
_RANGE(fam15h_HTC,1,3,1,1,1,1,8,7,1,4,3,33,0);
_NAMES(fam15h_HTC,"HtcEn",0,"HtcAct","HtcActSts","PslApicHiEn","PslApicLoEn",0,"HtcTmpLmt","HtcSlewSel","HtcHystLmt","HtcPstateLimit",0);
_RANGE(fam15h_MC0_CTL_MASK,1,1,1,1,1,1,1,1,1,55,0);
_NAMES(fam15h_MC0_CTL_MASK,"TagP","TLBP","DatP","LQP","SQP","SCBP","LineFillPoison","SRDE","IntErrType2",0);
_RANGE(fam15h_MC1_CTL_MASK,2,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,40,0);
_NAMES(fam15h_MC1_CTL_MASK,0,"IDP","IMTP","ISTP","L2TP","L1TP","LineFillPoison",0,"SRDE",0,"PFBP","PQP",0,"BSRP","DEPRP","DEUOPQP","DEIBP","DPDBE","DFIFOE","L2TLBM","L1TLBM","IVP",0);
_RANGE(fam15h_MC2_CTL_MASK,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,49,0);
_NAMES(fam15h_MC2_CTL_MASK,"L2TagMultiHit","VbData","WcbData","WccData","WccAddr","PrqData","PrqAddr","FillData","PrbAddr","XabAddr","L2Prefetch","L2TlbData","L2Tag","RdData","L2TlbPoison",0);
_RANGE(fam15h_MC3_CTL_MASK,64,0);
_NAMES(fam15h_MC3_CTL_MASK,0);
_RANGE(fam15h_MC4_CTL_MASK,1,1,3,3,1,1,1,1,1,1,1,1,1,1,1,4,1,1,1,1,1,3,1,32,0);
_NAMES(fam15h_MC4_CTL_MASK,"CECCEn","UECCEn","CrcErrEn","SyncPktEn","MstrAbrtEn","TgtAbrtEn","GartTblWkEn","AtomicRMWEn","WDTRptEn",0,"L3ArrayCorEn","L3ArrayUCEn","ProtEn","HtDataEn","DramParEn","RtryHtEn","CrcErrEn","SyncPktEn","McaUsPwDatErrEn","NbArrayParEn","TblWlkDatErrEn",0,"McaCpuDatErrEn",0);
_RANGE(fam15h_MC5_CTL_MASK,1,1,1,1,1,1,1,1,1,1,1,1,1,51,0);
_NAMES(fam15h_MC5_CTL_MASK,0,"PICWAK","PLDAG","PLDEX","IDF","RETDISP","MAP","EX0PRF","EX1PRF","AG0PRF","AG1PRF","FRF","DE",0);
_RANGE(fam15h_MC6_CTL_MASK,1,1,1,1,1,1,58,0);
_NAMES(fam15h_MC6_CTL_MASK,"PRF","FreeList","Sched",0,"RetireQ","SRF",0);
_RANGE(fam15h_SMI_ON_IO_TRAP_0,32,24,5,1,1,1,0);
_NAMES(fam15h_SMI_ON_IO_TRAP_0,"SmiAddr","SmiMask",0,"ConfigSmi","SmiOnWrEn","SmiOnRdEn");
_RANGE(fam15h_SMI_ON_IO_TRAP_1,32,24,5,1,1,1,0);
_NAMES(fam15h_SMI_ON_IO_TRAP_1,"SmiAddr","SmiMask",0,"ConfigSmi","SmiOnWrEn","SmiOnRdEn");
_RANGE(fam15h_SMI_ON_IO_TRAP_2,32,24,5,1,1,1,0);
_NAMES(fam15h_SMI_ON_IO_TRAP_2,"SmiAddr","SmiMask",0,"ConfigSmi","SmiOnWrEn","SmiOnRdEn");
_RANGE(fam15h_SMI_ON_IO_TRAP_3,32,24,5,1,1,1,0);
_NAMES(fam15h_SMI_ON_IO_TRAP_3,"SmiAddr","SmiMask",0,"ConfigSmi","SmiOnWrEn","SmiOnRdEn");
_RANGE(fam15h_SMI_ON_IO_TRAP_CTL_STS,1,1,1,1,1,1,1,1,7,1,48,0);
_NAMES(fam15h_SMI_ON_IO_TRAP_CTL_STS,0,"SmiEn_0",0,"SmiEn_1",0,"SmiEn_2",0,"SmiEn_3",0,"IoTrapEn",0);
_RANGE(fam15h_IntPendingMessage,16,8,1,1,1,2,1,34,0);
_NAMES(fam15h_IntPendingMessage,"IOMsgAddr","IOMsgData","IntrPndMsgDis","IntrPndMsg","IORd",0,"BmStsClrOnHaltEn",0);
_RANGE(fam15h_SmiTriggerIoCycle,16,8,1,1,1,37,0);
_NAMES(fam15h_SmiTriggerIoCycle,"IoPortAddress","IoData",0,"IoCycleEn","IoRd",0);
_RANGE(fam15h_MmioConfigBase,1,1,4,14,28,16,0);
_NAMES(fam15h_MmioConfigBase,"Enable",0,"SegBusRange",0,"MmiocCfgBaseAddr",0);
_RANGE(fam15h_BistResults,64,0);
_NAMES(fam15h_BistResults,0);
_RANGE(fam15h_PstateCurrentLimit,3,1,3,57,0);
_NAMES(fam15h_PstateCurrentLimit,"CurPstateLimit",0,"PstateMaxVal",0);
_RANGE(fam15h_PstateControl,3,61,0);
_NAMES(fam15h_PstateControl,"PstateCmd",0);
_RANGE(fam15h_PstateStatus,3,61,0);
_NAMES(fam15h_PstateStatus,"CurPstate",0);
_RANGE(fam15h_Pstate0,6,3,7,6,1,9,8,2,21,1,0);
_NAMES(fam15h_Pstate0,"CpuFid","CpuDid","CpuVid",0,"NbPstate",0,"IddValue","IddDiv",0,"PstateEn");
_RANGE(fam15h_Pstate1,6,3,7,6,1,9,8,2,21,1,0);
_NAMES(fam15h_Pstate1,"CpuFid","CpuDid","CpuVid",0,"NbPstate",0,"IddValue","IddDiv",0,"PstateEn");
_RANGE(fam15h_Pstate2,6,3,7,6,1,9,8,2,21,1,0);
_NAMES(fam15h_Pstate2,"CpuFid","CpuDid","CpuVid",0,"NbPstate",0,"IddValue","IddDiv",0,"PstateEn");
_RANGE(fam15h_Pstate3,6,3,7,6,1,9,8,2,21,1,0);
_NAMES(fam15h_Pstate3,"CpuFid","CpuDid","CpuVid",0,"NbPstate",0,"IddValue","IddDiv",0,"PstateEn");
_RANGE(fam15h_Pstate4,6,3,7,6,1,9,8,2,21,1,0);
_NAMES(fam15h_Pstate4,"CpuFid","CpuDid","CpuVid",0,"NbPstate",0,"IddValue","IddDiv",0,"PstateEn");
_RANGE(fam15h_Pstate5,6,3,7,6,1,9,8,2,21,1,0);
_NAMES(fam15h_Pstate5,"CpuFid","CpuDid","CpuVid",0,"NbPstate",0,"IddValue","IddDiv",0,"PstateEn");
_RANGE(fam15h_Pstate6,6,3,7,6,1,9,8,2,21,1,0);
_NAMES(fam15h_Pstate6,"CpuFid","CpuDid","CpuVid",0,"NbPstate",0,"IddValue","IddDiv",0,"PstateEn");
_RANGE(fam15h_Pstate7,6,3,7,6,1,9,8,2,21,1,0);
_NAMES(fam15h_Pstate7,"CpuFid","CpuDid","CpuVid",0,"NbPstate",0,"IddValue","IddDiv",0,"PstateEn");
_RANGE(fam15h_COFVIDcontrol,6,3,7,3,3,1,1,8,32,0);
_NAMES(fam15h_COFVIDcontrol,"CpuFid","CpuDid","CpuVid","PstateId",0,"NbPstate",0,"NbVid",0);
_RANGE(fam15h_COFVIDstatus,6,3,7,3,4,1,1,7,3,7,7,6,1,3,5,0);
_NAMES(fam15h_COFVIDstatus,"CurCpuFid","CurCpuDid","CurCpuVid","CurPstate",0,"NbPstateDis",0,"CurNbVid","StartupPstate","MaxVid","MinVid","MaxCpuCof",0,"CurPstateLimit","MaxNbCof");
_RANGE(fam15h_CstateAddress,16,48,0);
_NAMES(fam15h_CstateAddress,"CstateAddr",0);
_RANGE(fam15h_SMM_BASE,32,32,0);
_NAMES(fam15h_SMM_BASE,"SMM_BASE",0);
_RANGE(fam15h_SMMAddr,17,31,16,0);
_NAMES(fam15h_SMMAddr,0,"TSegBase",0);
_RANGE(fam15h_SMMMask,1,1,1,1,1,1,2,3,1,3,2,31,16,0);
_NAMES(fam15h_SMMMask,"AValid","TValid","AClose","TClose","AMTypeIoWc","TMTypeIoWc",0,"AMTypeDram",0,"TMTypeDram",0,"TSegMask",0);
_RANGE(fam15h_VM_CR,1,1,1,1,1,59,0);
_NAMES(fam15h_VM_CR,"dpd","InterceptInit","DisA20m","Lock","SvmeDisable",0);
_RANGE(fam15h_IGNNE,1,63,0);
_NAMES(fam15h_IGNNE,"IGNNE",0);
_RANGE(fam15h_VM_HSAVE_PA,12,36,16,0);
_NAMES(fam15h_VM_HSAVE_PA,0,"VM_HSAVE_PA",0);
_RANGE(fam15h_SMIstatus,4,4,1,1,1,5,1,1,1,1,1,1,1,41,0);
_NAMES(fam15h_SMIstatus,"IoTrapSts",0,"MceRedirSts",0,"IntPendSmiSts",0,"SmiSrcLvtLcy","SmiSrcLvtExt","SmiSrcThrCntDram","SmiSrcThrCntHt","SmiSrcThrCntL3",0,"SmiSrcOnLineSpare",0);
_RANGE(fam15h_OSVW_ID_Length,16,48,0);
_NAMES(fam15h_OSVW_ID_Length,"OSVW_ID_Length",0);
_RANGE(fam15h_OsvwStatus,64,0);
_NAMES(fam15h_OsvwStatus,"OsvwStatusBits");
_RANGE(fam15h_PERF_CTL0,8,8,2,1,1,1,1,1,1,8,4,4,2,22,0);
_NAMES(fam15h_PERF_CTL0,"EventSelect","UnitMask","OsUserMode","Edge",0,"Int",0,"En","Inv","CntMask","EventSelect",0,"HostGuestOnly",0);
_RANGE(fam15h_PERF_CTR0,48,16,0);
_NAMES(fam15h_PERF_CTR0,"CTR",0);
_RANGE(fam15h_PERF_CTL1,8,8,2,1,1,1,1,1,1,8,4,4,2,22,0);
_NAMES(fam15h_PERF_CTL1,"EventSelect","UnitMask","OsUserMode","Edge",0,"Int",0,"En","Inv","CntMask","EventSelect",0,"HostGuestOnly",0);
_RANGE(fam15h_PERF_CTR1,48,16,0);
_NAMES(fam15h_PERF_CTR1,"CTR",0);
_RANGE(fam15h_PERF_CTL2,8,8,2,1,1,1,1,1,1,8,4,4,2,22,0);
_NAMES(fam15h_PERF_CTL2,"EventSelect","UnitMask","OsUserMode","Edge",0,"Int",0,"En","Inv","CntMask","EventSelect",0,"HostGuestOnly",0);
_RANGE(fam15h_PERF_CTR2,48,16,0);
_NAMES(fam15h_PERF_CTR2,"CTR",0);
_RANGE(fam15h_PERF_CTL3,8,8,2,1,1,1,1,1,1,8,4,4,2,22,0);
_NAMES(fam15h_PERF_CTL3,"EventSelect","UnitMask","OsUserMode","Edge",0,"Int",0,"En","Inv","CntMask","EventSelect",0,"HostGuestOnly",0);
_RANGE(fam15h_PERF_CTR3,48,16,0);
_NAMES(fam15h_PERF_CTR3,"CTR",0);
_RANGE(fam15h_PERF_CTL4,8,8,2,1,1,1,1,1,1,8,4,4,2,22,0);
_NAMES(fam15h_PERF_CTL4,"EventSelect","UnitMask","OsUserMode","Edge",0,"Int",0,"En","Inv","CntMask","EventSelect",0,"HostGuestOnly",0);
_RANGE(fam15h_PERF_CTR4,48,16,0);
_NAMES(fam15h_PERF_CTR4,"CTR",0);
_RANGE(fam15h_PERF_CTL5,8,8,2,1,1,1,1,1,1,8,4,4,2,22,0);
_NAMES(fam15h_PERF_CTL5,"EventSelect","UnitMask","OsUserMode","Edge",0,"Int",0,"En","Inv","CntMask","EventSelect",0,"HostGuestOnly",0);
_RANGE(fam15h_PERF_CTR5,48,16,0);
_NAMES(fam15h_PERF_CTR5,"CTR",0);
_RANGE(fam15h_NB_PERF_CTL0,8,8,4,1,1,1,9,4,28,0);
_NAMES(fam15h_NB_PERF_CTL0,"EventSelect","UnitMask",0,"Int",0,"En",0,"EventSelect",0);
_RANGE(fam15h_NB_PERF_CTR0,48,16,0);
_NAMES(fam15h_NB_PERF_CTR0,"CTR",0);
_RANGE(fam15h_NB_PERF_CTL1,8,8,4,1,1,1,9,4,28,0);
_NAMES(fam15h_NB_PERF_CTL1,"EventSelect","UnitMask",0,"Int",0,"En",0,"EventSelect",0);
_RANGE(fam15h_NB_PERF_CTR1,48,16,0);
_NAMES(fam15h_NB_PERF_CTR1,"CTR",0);
_RANGE(fam15h_NB_PERF_CTL2,8,8,4,1,1,1,9,4,28,0);
_NAMES(fam15h_NB_PERF_CTL2,"EventSelect","UnitMask",0,"Int",0,"En",0,"EventSelect",0);
_RANGE(fam15h_NB_PERF_CTR2,48,16,0);
_NAMES(fam15h_NB_PERF_CTR2,"CTR",0);
_RANGE(fam15h_NB_PERF_CTL3,8,8,4,1,1,1,9,4,28,0);
_NAMES(fam15h_NB_PERF_CTL3,"EventSelect","UnitMask",0,"Int",0,"En",0,"EventSelect",0);
_RANGE(fam15h_NB_PERF_CTR3,48,16,0);
_NAMES(fam15h_NB_PERF_CTR3,"CTR",0);
_RANGE(fam15h_CPUIDPmFeatures,32,32,0);
_NAMES(fam15h_CPUIDPmFeatures,"FeaturesEcx",0);
_RANGE(fam15h_CPUIDFeatures,32,32,0);
_NAMES(fam15h_CPUIDFeatures,"FeaturesEdx","FeaturesEcx");
_RANGE(fam15h_CPUIDExtFeatures,32,32,0);
_NAMES(fam15h_CPUIDExtFeatures,"ExtFeaturesEdx","ExtFeaturesEcx");
_RANGE(fam15h_LS_CFG,28,1,35,0);
_NAMES(fam15h_LS_CFG,0,"DIS_SS",0);
_RANGE(fam15h_IC_CFG,9,1,54,0);
_NAMES(fam15h_IC_CFG,0,"DIS_SPEC_TLB_RLD",0);
_RANGE(fam15h_DC_CFG,4,1,8,1,50,0);
_NAMES(fam15h_DC_CFG,0,"DIS_SPEC_TLB_RLD",0,"DIS_HW_PF",0);
_RANGE(fam15h_CU_CFG,10,1,8,4,1,40,0);
_NAMES(fam15h_CU_CFG,0,"DcacheAgressivePriority",0,"L2FirstLockedWay","L2WayLock",0);
_RANGE(fam15h_FP_CFG,16,1,1,5,2,2,8,29,0);
_NAMES(fam15h_FP_CFG,0,"DiDtMode",0,"DiDtCfg0",0,"DiDtCfg2","DiDtCfg1",0);
_RANGE(fam15h_DE_CFG,10,1,53,0);
_NAMES(fam15h_DE_CFG,0,"ResyncPredSingleDispDis",0);
_RANGE(fam15h_CU_CFG2,6,2,2,1,25,2,4,1,7,1,13,0);
_NAMES(fam15h_CU_CFG2,0,"ThrottleNbInterface",0,"VicResyncChkEn",0,"ThrottleNbInterface",0,"ProbeFilterSupEn",0,"RdMmExtCfgQwEn",0);
_RANGE(fam15h_CU_CFG3,42,1,6,1,1,2,11,0);
_NAMES(fam15h_CU_CFG3,0,"PwcDisableWalkerSharing",0,"CombineCr0Cd","AsidIncrScaleFactor","AsidDecrScaleFactor",0);
_RANGE(fam15h_EX_CFG,64,0);
_NAMES(fam15h_EX_CFG,0);
_RANGE(fam15h_IbsFetchCtl,16,16,16,1,1,1,1,1,2,1,1,1,6,0);
_NAMES(fam15h_IbsFetchCtl,"IbsFetchMaxCnt","IbsFetchCnt","IbsFetchLat","IbsFetchEn","IbsFetchVal","IbsFetchComp","IbsIcMiss","IbsPhyAddrValid","IbsL1TlbPgSz","IbsL1TlbMiss","IbsL2TlbMiss","IbsRandEn",0);
_RANGE(fam15h_IbsFetchLinAd,64,0);
_NAMES(fam15h_IbsFetchLinAd,"IbsFetchLinAd");
_RANGE(fam15h_IbsFetchPhysAd,64,0);
_NAMES(fam15h_IbsFetchPhysAd,"IbsFetchPhysAd");
_RANGE(fam15h_IbsOpCtl,16,1,1,1,1,7,5,27,5,0);
_NAMES(fam15h_IbsOpCtl,"IbsOpMaxCnt",0,"IbsOpEn","IbsOpVal","IbsOpCntCtl","IbsOpMaxCnt",0,"IbsOpCurCnt",0);
_RANGE(fam15h_IbsOpRip,64,0);
_NAMES(fam15h_IbsOpRip,"IbsOpRip");
_RANGE(fam15h_IbsOpData,16,16,1,1,1,1,1,1,1,25,0);
_NAMES(fam15h_IbsOpData,"IbsCompToRetCtr","IbsTagToRetCtr","IbsOpBrnResync","IbsOpMispReturn","IbsOpReturn","IbsOpBrnTaken","IbsOpBrnMisp","IbsOpBrnRet","IbsRipInvalid",0);
_RANGE(fam15h_IbsOpData2,3,1,1,1,58,0);
_NAMES(fam15h_IbsOpData2,"NbIbsReqSrc",0,"NbIbsReqDstNode","NbIbsReqCacheHitSt",0);
_RANGE(fam15h_IbsOpData3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,12,16,16,0);
_NAMES(fam15h_IbsOpData3,"IbsLdOp","IbsStOp","IbsDcL1tlbMiss","IbsDcL2tlbMiss","IbsDcL1tlbHit2M","IbsDcL1tlbHit1G","IbsDcL2tlbHit2M","IbsDcMiss","IbsDcMisAcc","IbsDcLdBnkCon",0,"IbsDcStToLdFwd","IbsDcStToLdCan","IbsDcWcMemAcc","IbsDcUcMemAcc","IbsDcLockedOp","IbsDcMabHit","IbsDcLinAddrValid","IbsDcPhyAddrValid","IbsDcL2tlbHit1G",0,"IbsDcMissLat",0);
_RANGE(fam15h_IbsDcLinAd,64,0);
_NAMES(fam15h_IbsDcLinAd,"IbsDcLinAd");
_RANGE(fam15h_IbsDcPhysAd,64,0);
_NAMES(fam15h_IbsDcPhysAd,"IbsDcPhysAd");
_RANGE(fam15h_IbsControl,4,4,1,55,0);
_NAMES(fam15h_IbsControl,"LvtOffset",0,"LvtOffsetVal",0);
_RANGE(fam15h_IbsBranchTargetAddress,64,0);
_NAMES(fam15h_IbsBranchTargetAddress,"IbsBrTarget");

struct reg_spec fam15h_spec [] = {
	_SPEC(0x0000, LSMCAaddr, "load-store MCA address", fam15h_),
	_SPEC(0x0001, LSMCAstatus, "load-store MCE status", fam15h_),
	_SPEC(0x0010, TSC, "time-stamp counter", fam15h_),
	_SPEC(0x001b, APIC_BASE, "APIC base address", fam15h_),
	_SPEC(0x002a, EBL_CR_POWERON, "cluster ID", fam15h_),
	_SPEC(0x008b, PATCH_LEVEL, "microcode patch level (sharedC)", fam15h_),
	_SPEC(0x00e7, MPERF, "max performance frequency clock count", fam15h_),
	_SPEC(0x00e8, APERF, "actual performance frequency clock count", fam15h_),
	_SPEC(0x00fe, MTRRcap, "MTRR capabilities", fam15h_),
	_SPEC(0x0174, SYSENTER_CS, "SYSENTER/SYSEXIT code segment selector", fam15h_),
	_SPEC(0x0175, SYSENTER_ESP, "SYSENTER/SYSEXIT stack pointer", fam15h_),
	_SPEC(0x0176, SYSENTER_EIP, "SYSENTER/SYSEXIT instruction pointer", fam15h_),
	_SPEC(0x0179, MCG_CAP, "global MC capabilities", fam15h_),
	_SPEC(0x017a, MCG_STAT, "global MC status", fam15h_),
	_SPEC(0x017b, MCG_CTL, "global MC control", fam15h_),
	_SPEC(0x01d9, DBG_CTL_MSR, "debug control", fam15h_),
	_SPEC(0x01db, BR_FROM, "last branch from IP", fam15h_),
	_SPEC(0x01dc, BR_TO, "last branch to IP", fam15h_),
	_SPEC(0x01dd, LastExceptionFromIP, "last exception from IP", fam15h_),
	_SPEC(0x01de, LastExceptionToIP, "last exception to IP", fam15h_),
	_SPEC(0x0200, MTRRphysBase0, "base of variable-size MTRR (0) (sharedC)", fam15h_),
	_SPEC(0x0201, MTRRphysMask0, "mask of variable-size MTRR (0) (sharedC)", fam15h_),
	_SPEC(0x0202, MTRRphysBase1, "base of variable-size MTRR (1) (sharedC)", fam15h_),
	_SPEC(0x0203, MTRRphysMask1, "mask of variable-size MTRR (1) (sharedC)", fam15h_),
	_SPEC(0x0204, MTRRphysBase2, "base of variable-size MTRR (2) (sharedC)", fam15h_),
	_SPEC(0x0205, MTRRphysMask2, "mask of variable-size MTRR (2) (sharedC)", fam15h_),
	_SPEC(0x0206, MTRRphysBase3, "base of variable-size MTRR (3) (sharedC)", fam15h_),
	_SPEC(0x0207, MTRRphysMask3, "mask of variable-size MTRR (3) (sharedC)", fam15h_),
	_SPEC(0x0208, MTRRphysBase4, "base of variable-size MTRR (4) (sharedC)", fam15h_),
	_SPEC(0x0209, MTRRphysMask4, "mask of variable-size MTRR (4) (sharedC)", fam15h_),
	_SPEC(0x020a, MTRRphysBase5, "base of variable-size MTRR (5) (sharedC)", fam15h_),
	_SPEC(0x020b, MTRRphysMask5, "mask of variable-size MTRR (5) (sharedC)", fam15h_),
	_SPEC(0x020c, MTRRphysBase6, "base of variable-size MTRR (6) (sharedC)", fam15h_),
	_SPEC(0x020d, MTRRphysMask6, "mask of variable-size MTRR (6) (sharedC)", fam15h_),
	_SPEC(0x020e, MTRRphysBase7, "base of variable-size MTRR (7) (sharedC)", fam15h_),
	_SPEC(0x020f, MTRRphysMask7, "mask of variable-size MTRR (7) (sharedC)", fam15h_),
	_SPEC(0x0250, MTRRfix64K_00000, "fixed range MTRR (sharedC)", fam15h_),
	_SPEC(0x0258, MTRRfix16K_80000, "fixed range MTRR (sharedC)", fam15h_),
	_SPEC(0x0259, MTRRfix16K_A0000, "fixed range MTRR (sharedC)", fam15h_),
	_SPEC(0x0268, MTRRfix4K_C0000, "fixed range MTRR (sharedC)", fam15h_),
	_SPEC(0x0269, MTRRfix4K_C8000, "fixed range MTRR (sharedC)", fam15h_),
	_SPEC(0x026a, MTRRfix4K_D0000, "fixed range MTRR (sharedC)", fam15h_),
	_SPEC(0x026b, MTRRfix4K_D8000, "fixed range MTRR (sharedC)", fam15h_),
	_SPEC(0x026c, MTRRfix4K_E0000, "fixed range MTRR (sharedC)", fam15h_),
	_SPEC(0x026d, MTRRfix4K_E8000, "fixed range MTRR (sharedC)", fam15h_),
	_SPEC(0x026e, MTRRfix4K_F0000, "fixed range MTRR (sharedC)", fam15h_),
	_SPEC(0x026f, MTRRfix4K_F8000, "fixed range MTRR (sharedC)", fam15h_),
	_SPEC(0x0277, PAT, "page attribute table", fam15h_),
	_SPEC(0x02ff, MTRRdefType, "MTRR default memory type (sharedC)", fam15h_),
	_SPEC(0x0400, MC0_CTL, "load store MC control", fam15h_),
	_SPEC(0x0401, MC0_STATUS, "load store MC status", fam15h_),
	_SPEC(0x0402, MC0_ADDR, "load store MC address", fam15h_),
	_SPEC(0x0403, MC0_MISC, "load store MC miscellaneous", fam15h_),
	_SPEC(0x0404, MC1_CTL, "instruction fetch MC control (sharedC)", fam15h_),
	_SPEC(0x0405, MC1_STATUS, "instruction fetch MC status", fam15h_),
	_SPEC(0x0406, MC1_ADDR, "instruction fetch MC address", fam15h_),
	_SPEC(0x0407, MC1_MISC, "instruction fetch MC miscellaneous", fam15h_),
	_SPEC(0x0408, MC2_CTL, "combined unit MC control (sharedC)", fam15h_),
	_SPEC(0x0409, MC2_STATUS, "combined unit MC status", fam15h_),
	_SPEC(0x040a, MC2_ADDR, "combined unit MC address register", fam15h_),
	_SPEC(0x040b, MC2_MISC, "combined unit MC miscellaneous", fam15h_),
	_SPEC(0x040c, MC3_CTL, "reserved", fam15h_),
	_SPEC(0x040d, MC3_STATUS, "reserved", fam15h_),
	_SPEC(0x040e, MC3_ADDR, "reserved", fam15h_),
	_SPEC(0x040f, MC3_MISC, "reserved", fam15h_),
	_SPEC(0x0410, MC4_CTL, "northbridge MC control", fam15h_),
	_SPEC(0x0411, MC4_STATUS, "northbridge MC status", fam15h_),
	_SPEC(0x0412, MC4_ADDR, "northbridge MC address", fam15h_),
	_SPEC(0x0413, MC4_MISC0, "northbridge MC misc (DRAM Thresholding) (0)", fam15h_),
	_SPEC(0x0414, MC5_CTL, "execution unit MC control", fam15h_),
	_SPEC(0x0415, MC5_STATUS, "execution unit MC status", fam15h_),
	_SPEC(0x0416, MC5_ADDR, "execution unit MC address", fam15h_),
	_SPEC(0x0417, MC5_MISC, "execution unit MC miscellaneous", fam15h_),
	_SPEC(0x0418, MC6_CTL, "floating point unit MC control (sharedC)", fam15h_),
	_SPEC(0x0419, MC6_STATUS, "floating point unit MC status", fam15h_),
	_SPEC(0x041a, MC6_ADDR, "floating point unit MC address", fam15h_),
	_SPEC(0x041b, MC6_MISC, "floating point unit MC miscellaneous", fam15h_),
	_SPEC(0xc0000080, EFER, "extended feature enable", fam15h_),
	_SPEC(0xc0000081, STAR, "SYSCALL target address", fam15h_),
	_SPEC(0xc0000082, STAR64, "long mode SYSCALL target address", fam15h_),
	_SPEC(0xc0000083, STARCOMPAT, "compat mode SYSCALL target address", fam15h_),
	_SPEC(0xc0000084, SYSCALL_FLAG_MASK, "SYSCALL flag mask", fam15h_),
	_SPEC(0xc0000100, FS_BASE, "FS base", fam15h_),
	_SPEC(0xc0000101, GS_BASE, "GS base", fam15h_),
	_SPEC(0xc0000102, KernelGSbase, "kernel GS base", fam15h_),
	_SPEC(0xc0000103, TSC_AUX, "auxiliary time stamp counter data", fam15h_),
	_SPEC(0xc0000104, TscRateMsr, "time stamp counter ratio", fam15h_),
	_SPEC(0xc0000105, LWP_CFG, "lightweight profile configuration", fam15h_),
	_SPEC(0xc0000106, LWP_CBADDR, "leightweight profile control block address", fam15h_),
	_SPEC(0xc0000408, MC4_MISC1, "northbridge MC misc (Link Thresholding) (1)", fam15h_),
	_SPEC(0xc0000409, MC4_MISC2, "northbridge MC misc (L3 Thresholding) (2)", fam15h_),
	_SPEC(0xc000040a, MC4_MISC3, "reserved", fam15h_),
	_SPEC(0xc0010000, LEG_PERF_CTL0, "performance event select (0)", fam15h_),
	_SPEC(0xc0010001, LEG_PERF_CTL1, "performance event select (1)", fam15h_),
	_SPEC(0xc0010002, LEG_PERF_CTL2, "performance event select (2)", fam15h_),
	_SPEC(0xc0010003, LEG_PERF_CTL3, "performance event select (3)", fam15h_),
	_SPEC(0xc0010004, LEG_PERF_CTR0, "performance event counter (0)", fam15h_),
	_SPEC(0xc0010005, LEG_PERF_CTR1, "performance event counter (1)", fam15h_),
	_SPEC(0xc0010006, LEG_PERF_CTR2, "performance event counter (2)", fam15h_),
	_SPEC(0xc0010007, LEG_PERF_CTR3, "performance event counter (3)", fam15h_),
	_SPEC(0xc0010010, SYS_CFG, "system configuration (sharedC)", fam15h_),
	_SPEC(0xc0010015, HWCR, "hardware configuration", fam15h_),
	_SPEC(0xc0010016, IORR_BASE0, "base of variable I/O range (0) (sharedC)", fam15h_),
	_SPEC(0xc0010017, IORR_MASK0, "mask of variable I/O range (0) (sharedC)", fam15h_),
	_SPEC(0xc0010018, IORR_BASE1, "base of variable I/O range (1) (sharedC)", fam15h_),
	_SPEC(0xc0010019, IORR_MASK1, "mask of variable I/O range (1) (sharedC)", fam15h_),
	_SPEC(0xc001001a, TOP_MEM, "top of memory address (sharedC)", fam15h_),
	_SPEC(0xc001001d, TOM2, "second top of memory address (sharedC)", fam15h_),
	_SPEC(0xc001001f, NB_CFG, "northbridge configuration", fam15h_),
	_SPEC(0xc0010022, MCEredirection, "MCE redirection", fam15h_),
	_SPEC(0xc0010030, ProcessorNameString0, "processor name string (0) (sharedNC)", fam15h_),
	_SPEC(0xc0010031, ProcessorNameString1, "processor name string (1) (sharedNC)", fam15h_),
	_SPEC(0xc0010032, ProcessorNameString2, "processor name string (2) (sharedNC)", fam15h_),
	_SPEC(0xc0010033, ProcessorNameString3, "processor name string (3) (sharedNC)", fam15h_),
	_SPEC(0xc0010034, ProcessorNameString4, "processor name string (4) (sharedNC)", fam15h_),
	_SPEC(0xc0010035, ProcessorNameString5, "processor name string (5) (sharedNC)", fam15h_),
	_SPEC(0xc001003e, HTC, "hardware thermal control", fam15h_),
	_SPEC(0xc0010044, MC0_CTL_MASK, "load store MC control mask", fam15h_),
	_SPEC(0xc0010045, MC1_CTL_MASK, "instruction fetch MC control mask (sharedC)", fam15h_),
	_SPEC(0xc0010046, MC2_CTL_MASK, "bus unit MC control mask (sharedC)", fam15h_),
	_SPEC(0xc0010047, MC3_CTL_MASK, "reserved", fam15h_),
	_SPEC(0xc0010048, MC4_CTL_MASK, "northbridge MC control mask", fam15h_),
	_SPEC(0xc0010049, MC5_CTL_MASK, "execution unit MC control mask", fam15h_),
	_SPEC(0xc001004a, MC6_CTL_MASK, "floating point unit MC control mask (sharedC)", fam15h_),
	_SPEC(0xc0010050, SMI_ON_IO_TRAP_0, "IO trap address (0) (sharedNC)", fam15h_),
	_SPEC(0xc0010051, SMI_ON_IO_TRAP_1, "IO trap address (1) (sharedNC)", fam15h_),
	_SPEC(0xc0010052, SMI_ON_IO_TRAP_2, "IO trap address (2) (sharedNC)", fam15h_),
	_SPEC(0xc0010053, SMI_ON_IO_TRAP_3, "IO trap address (3) (sharedNC)", fam15h_),
	_SPEC(0xc0010054, SMI_ON_IO_TRAP_CTL_STS, "IO trap control (sharedNC)", fam15h_),
	_SPEC(0xc0010055, IntPendingMessage, "interrupt pending (sharedNC)", fam15h_),
	_SPEC(0xc0010056, SmiTriggerIoCycle, "SMI trigger IO cycle", fam15h_),
	_SPEC(0xc0010058, MmioConfigBase, "MMIO configuration base address", fam15h_),
	_SPEC(0xc0010060, BistResults, "BIST results", fam15h_),
	_SPEC(0xc0010061, PstateCurrentLimit, "P-state current limit (sharedC)", fam15h_),
	_SPEC(0xc0010062, PstateControl, "P-state control", fam15h_),
	_SPEC(0xc0010063, PstateStatus, "P-state status (sharedC)", fam15h_),
	_SPEC(0xc0010064, Pstate0, "P-state 0 (sharedC)", fam15h_),
	_SPEC(0xc0010065, Pstate1, "P-state 1 (sharedC)", fam15h_),
	_SPEC(0xc0010066, Pstate2, "P-state 2 (sharedC)", fam15h_),
	_SPEC(0xc0010067, Pstate3, "P-state 3 (sharedC)", fam15h_),
	_SPEC(0xc0010068, Pstate4, "P-state 4 (sharedC)", fam15h_),
	_SPEC(0xc0010069, Pstate5, "P-state 5 (sharedC)", fam15h_),
	_SPEC(0xc001006a, Pstate6, "P-state 6 (sharedC)", fam15h_),
	_SPEC(0xc001006b, Pstate7, "P-state 7 (sharedC)", fam15h_),
	_SPEC(0xc0010070, COFVIDcontrol, "COFVID control", fam15h_),
	_SPEC(0xc0010071, COFVIDstatus, "COFVID status", fam15h_),
	_SPEC(0xc0010073, CstateAddress, "C-state address", fam15h_),
	_SPEC(0xc0010111, SMM_BASE, "SMM base address", fam15h_),
	_SPEC(0xc0010112, SMMAddr, "SMM TSeg base address", fam15h_),
	_SPEC(0xc0010113, SMMMask, "SMM Tseg mask", fam15h_),
	_SPEC(0xc0010114, VM_CR, "virtual machine control", fam15h_),
	_SPEC(0xc0010115, IGNNE, "IGNNE", fam15h_),
	_SPEC(0xc0010117, VM_HSAVE_PA, "virtual machine host save physical address", fam15h_),
	_SPEC(0xc001011a, SMIstatus, "local SMI status", fam15h_),
	_SPEC(0xc0010140, OSVW_ID_Length, "OS visible work-around", fam15h_),
	_SPEC(0xc0010141, OsvwStatus, "OS visible work-around status bits", fam15h_),
	_SPEC(0xc0010200, PERF_CTL0, "performance event select (0)", fam15h_),
	_SPEC(0xc0010201, PERF_CTR0, "performance event counter (0)", fam15h_),
	_SPEC(0xc0010202, PERF_CTL1, "performance event select (1)", fam15h_),
	_SPEC(0xc0010203, PERF_CTR1, "performance event counter (1)", fam15h_),
	_SPEC(0xc0010204, PERF_CTL2, "performance event select (2)", fam15h_),
	_SPEC(0xc0010205, PERF_CTR2, "performance event counter (2)", fam15h_),
	_SPEC(0xc0010206, PERF_CTL3, "performance event select (3)", fam15h_),
	_SPEC(0xc0010207, PERF_CTR3, "performance event counter (3)", fam15h_),
	_SPEC(0xc0010208, PERF_CTL4, "performance event select (4)", fam15h_),
	_SPEC(0xc0010209, PERF_CTR4, "performance event counter (4)", fam15h_),
	_SPEC(0xc001020a, PERF_CTL5, "performance event select (5)", fam15h_),
	_SPEC(0xc001020b, PERF_CTR5, "performance event counter (5)", fam15h_),
	_SPEC(0xc0010240, NB_PERF_CTL0, "northbridge performance event select (0)", fam15h_),
	_SPEC(0xc0010241, NB_PERF_CTR0, "northbridge performance event counter (0)", fam15h_),
	_SPEC(0xc0010242, NB_PERF_CTL1, "northbridge performance event select (1)", fam15h_),
	_SPEC(0xc0010243, NB_PERF_CTR1, "northbridge performance event counter (1)", fam15h_),
	_SPEC(0xc0010244, NB_PERF_CTL2, "northbridge performance event select (2)", fam15h_),
	_SPEC(0xc0010245, NB_PERF_CTR2, "northbridge performance event counter (2)", fam15h_),
	_SPEC(0xc0010246, NB_PERF_CTL3, "northbridge performance event select (3)", fam15h_),
	_SPEC(0xc0010247, NB_PERF_CTR3, "northbridge performance event counter (3)", fam15h_),
	_SPEC(0xc0011003, CPUIDPmFeatures, "thermal and power management CPUID features", fam15h_),
	_SPEC(0xc0011004, CPUIDFeatures, "CPUID features", fam15h_),
	_SPEC(0xc0011005, CPUIDExtFeatures, "extended CPUID features", fam15h_),
	_SPEC(0xc0011020, LS_CFG, "load store configuration", fam15h_),
	_SPEC(0xc0011021, IC_CFG, "instruction cache configuration (sharedC)", fam15h_),
	_SPEC(0xc0011022, DC_CFG, "data cache configuration", fam15h_),
	_SPEC(0xc0011023, CU_CFG, "combined unit configuration (sharedC)", fam15h_),
	_SPEC(0xc0011028, FP_CFG, "floating point configuration (sharedC)", fam15h_),
	_SPEC(0xc0011029, DE_CFG, "decode configuration (sharedC)", fam15h_),
	_SPEC(0xc001102A, CU_CFG2, "combined unit configuration 2 (sharedC)", fam15h_),
	_SPEC(0xc001102B, CU_CFG3, "combined unit configuration 3 (sharedC)", fam15h_),
	_SPEC(0xc001102C, EX_CFG, "execution unit configuration", fam15h_),
	_SPEC(0xc0011030, IbsFetchCtl, "IBS fetch control", fam15h_),
	_SPEC(0xc0011031, IbsFetchLinAd, "IBS fetch linear address", fam15h_),
	_SPEC(0xc0011032, IbsFetchPhysAd, "IBS fetch physical address", fam15h_),
	_SPEC(0xc0011033, IbsOpCtl, "IBS execution control", fam15h_),
	_SPEC(0xc0011034, IbsOpRip, "IBS Op logical address", fam15h_),
	_SPEC(0xc0011035, IbsOpData, "IBS Op data", fam15h_),
	_SPEC(0xc0011036, IbsOpData2, "IBS Op data 2", fam15h_),
	_SPEC(0xc0011037, IbsOpData3, "IBS Op data 3", fam15h_),
	_SPEC(0xc0011038, IbsDcLinAd, "IBS DC linear address", fam15h_),
	_SPEC(0xc0011039, IbsDcPhysAd, "IBS DC physical address", fam15h_),
	_SPEC(0xc001103a, IbsControl, "IBS control", fam15h_),
	_SPEC(0xc001103b, IbsBranchTargetAddress, "IBS branch target address", fam15h_),
	{0, NULL, NULL, NULL, NULL},
};

#endif /* fam15h_h */
